/* valabinaryexpression.c generated by valac, the Vala compiler
 * generated from valabinaryexpression.vala, do not modify */

/* valabinaryexpression.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _ValaBinaryExpressionPrivate {
	ValaBinaryOperator _operator;
	ValaExpression* _left;
	ValaExpression* _right;
};


static gpointer vala_binary_expression_parent_class = NULL;

#define VALA_BINARY_EXPRESSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_BINARY_EXPRESSION, ValaBinaryExpressionPrivate))
static void vala_binary_expression_real_accept (ValaCodeNode* base, ValaCodeVisitor* visitor);
static void vala_binary_expression_real_accept_children (ValaCodeNode* base, ValaCodeVisitor* visitor);
static void vala_binary_expression_real_replace_expression (ValaCodeNode* base, ValaExpression* old_node, ValaExpression* new_node);
static const gchar* vala_binary_expression_get_operator_string (ValaBinaryExpression* self);
static gchar* vala_binary_expression_real_to_string (ValaCodeNode* base);
static gboolean vala_binary_expression_real_is_constant (ValaExpression* base);
static gboolean vala_binary_expression_real_is_pure (ValaExpression* base);
static gboolean vala_binary_expression_real_is_non_null (ValaExpression* base);
static gboolean vala_binary_expression_real_is_accessible (ValaExpression* base, ValaSymbol* sym);
static gboolean vala_binary_expression_real_check (ValaCodeNode* base, ValaCodeContext* context);
static void vala_binary_expression_real_emit (ValaCodeNode* base, ValaCodeGenerator* codegen);
static void vala_binary_expression_real_get_defined_variables (ValaCodeNode* base, ValaCollection* collection);
static void vala_binary_expression_real_get_used_variables (ValaCodeNode* base, ValaCollection* collection);
static void vala_binary_expression_finalize (ValaCodeNode * obj);


/**
 * Creates a new binary expression.
 *
 * @param op      binary operator
 * @param _left   left operand
 * @param _right  right operand
 * @param source  reference to source code
 * @return        newly created binary expression
 */
ValaBinaryExpression* vala_binary_expression_construct (GType object_type, ValaBinaryOperator op, ValaExpression* _left, ValaExpression* _right, ValaSourceReference* source) {
	ValaBinaryExpression* self = NULL;
	ValaBinaryOperator _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaSourceReference* _tmp3_;
	g_return_val_if_fail (_left != NULL, NULL);
	g_return_val_if_fail (_right != NULL, NULL);
	self = (ValaBinaryExpression*) vala_expression_construct (object_type);
	_tmp0_ = op;
	vala_binary_expression_set_operator (self, _tmp0_);
	_tmp1_ = _left;
	vala_binary_expression_set_left (self, _tmp1_);
	_tmp2_ = _right;
	vala_binary_expression_set_right (self, _tmp2_);
	_tmp3_ = source;
	vala_code_node_set_source_reference ((ValaCodeNode*) self, _tmp3_);
	return self;
}


ValaBinaryExpression* vala_binary_expression_new (ValaBinaryOperator op, ValaExpression* _left, ValaExpression* _right, ValaSourceReference* source) {
	return vala_binary_expression_construct (VALA_TYPE_BINARY_EXPRESSION, op, _left, _right, source);
}


static void vala_binary_expression_real_accept (ValaCodeNode* base, ValaCodeVisitor* visitor) {
	ValaBinaryExpression * self;
	ValaCodeVisitor* _tmp0_;
	ValaCodeVisitor* _tmp1_;
	self = (ValaBinaryExpression*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = visitor;
	vala_code_visitor_visit_binary_expression (_tmp0_, self);
	_tmp1_ = visitor;
	vala_code_visitor_visit_expression (_tmp1_, (ValaExpression*) self);
}


static void vala_binary_expression_real_accept_children (ValaCodeNode* base, ValaCodeVisitor* visitor) {
	ValaBinaryExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCodeVisitor* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaCodeVisitor* _tmp5_;
	self = (ValaBinaryExpression*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_binary_expression_get_left (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = visitor;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, _tmp2_);
	_tmp3_ = vala_binary_expression_get_right (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = visitor;
	vala_code_node_accept ((ValaCodeNode*) _tmp4_, _tmp5_);
}


static void vala_binary_expression_real_replace_expression (ValaCodeNode* base, ValaExpression* old_node, ValaExpression* new_node) {
	ValaBinaryExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	ValaExpression* _tmp6_;
	self = (ValaBinaryExpression*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	_tmp0_ = vala_binary_expression_get_left (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = old_node;
	if (_tmp1_ == _tmp2_) {
		ValaExpression* _tmp3_;
		_tmp3_ = new_node;
		vala_binary_expression_set_left (self, _tmp3_);
	}
	_tmp4_ = vala_binary_expression_get_right (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = old_node;
	if (_tmp5_ == _tmp6_) {
		ValaExpression* _tmp7_;
		_tmp7_ = new_node;
		vala_binary_expression_set_right (self, _tmp7_);
	}
}


static const gchar* vala_binary_expression_get_operator_string (ValaBinaryExpression* self) {
	const gchar* result = NULL;
	ValaBinaryOperator _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_operator;
	switch (_tmp0_) {
		case VALA_BINARY_OPERATOR_PLUS:
		{
			result = "+";
			return result;
		}
		case VALA_BINARY_OPERATOR_MINUS:
		{
			result = "-";
			return result;
		}
		case VALA_BINARY_OPERATOR_MUL:
		{
			result = "*";
			return result;
		}
		case VALA_BINARY_OPERATOR_DIV:
		{
			result = "/";
			return result;
		}
		case VALA_BINARY_OPERATOR_MOD:
		{
			result = "%";
			return result;
		}
		case VALA_BINARY_OPERATOR_SHIFT_LEFT:
		{
			result = "<<";
			return result;
		}
		case VALA_BINARY_OPERATOR_SHIFT_RIGHT:
		{
			result = ">>";
			return result;
		}
		case VALA_BINARY_OPERATOR_LESS_THAN:
		{
			result = "<";
			return result;
		}
		case VALA_BINARY_OPERATOR_GREATER_THAN:
		{
			result = ">";
			return result;
		}
		case VALA_BINARY_OPERATOR_LESS_THAN_OR_EQUAL:
		{
			result = "<=";
			return result;
		}
		case VALA_BINARY_OPERATOR_GREATER_THAN_OR_EQUAL:
		{
			result = ">=";
			return result;
		}
		case VALA_BINARY_OPERATOR_EQUALITY:
		{
			result = "==";
			return result;
		}
		case VALA_BINARY_OPERATOR_INEQUALITY:
		{
			result = "!=";
			return result;
		}
		case VALA_BINARY_OPERATOR_BITWISE_AND:
		{
			result = "&";
			return result;
		}
		case VALA_BINARY_OPERATOR_BITWISE_OR:
		{
			result = "|";
			return result;
		}
		case VALA_BINARY_OPERATOR_BITWISE_XOR:
		{
			result = "^";
			return result;
		}
		case VALA_BINARY_OPERATOR_AND:
		{
			result = "&&";
			return result;
		}
		case VALA_BINARY_OPERATOR_OR:
		{
			result = "||";
			return result;
		}
		case VALA_BINARY_OPERATOR_IN:
		{
			result = "in";
			return result;
		}
		case VALA_BINARY_OPERATOR_COALESCE:
		{
			result = "??";
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


static gchar* vala_binary_expression_real_to_string (ValaCodeNode* base) {
	ValaBinaryExpression * self;
	gchar* result = NULL;
	ValaExpression* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	ValaExpression* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	self = (ValaBinaryExpression*) base;
	_tmp0_ = self->priv->_left;
	_tmp1_ = vala_code_node_to_string ((ValaCodeNode*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_binary_expression_get_operator_string (self);
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->_right;
	_tmp7_ = vala_code_node_to_string ((ValaCodeNode*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
	result = _tmp10_;
	return result;
}


static gboolean vala_binary_expression_real_is_constant (ValaExpression* base) {
	ValaBinaryExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	gboolean _tmp3_;
	self = (ValaBinaryExpression*) base;
	_tmp1_ = vala_binary_expression_get_left (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_expression_is_constant (_tmp2_);
	if (_tmp3_) {
		ValaExpression* _tmp4_;
		ValaExpression* _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = vala_binary_expression_get_right (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_expression_is_constant (_tmp5_);
		_tmp0_ = _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gboolean vala_binary_expression_real_is_pure (ValaExpression* base) {
	ValaBinaryExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	gboolean _tmp3_;
	self = (ValaBinaryExpression*) base;
	_tmp1_ = vala_binary_expression_get_left (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_expression_is_pure (_tmp2_);
	if (_tmp3_) {
		ValaExpression* _tmp4_;
		ValaExpression* _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = vala_binary_expression_get_right (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_expression_is_pure (_tmp5_);
		_tmp0_ = _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gboolean vala_binary_expression_real_is_non_null (ValaExpression* base) {
	ValaBinaryExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	gboolean _tmp3_;
	self = (ValaBinaryExpression*) base;
	_tmp1_ = vala_binary_expression_get_left (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_expression_is_non_null (_tmp2_);
	if (_tmp3_) {
		ValaExpression* _tmp4_;
		ValaExpression* _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = vala_binary_expression_get_right (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_expression_is_non_null (_tmp5_);
		_tmp0_ = _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gboolean vala_binary_expression_real_is_accessible (ValaExpression* base, ValaSymbol* sym) {
	ValaBinaryExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	ValaSymbol* _tmp3_;
	gboolean _tmp4_;
	self = (ValaBinaryExpression*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	_tmp1_ = vala_binary_expression_get_left (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = sym;
	_tmp4_ = vala_expression_is_accessible (_tmp2_, _tmp3_);
	if (_tmp4_) {
		ValaExpression* _tmp5_;
		ValaExpression* _tmp6_;
		ValaSymbol* _tmp7_;
		gboolean _tmp8_;
		_tmp5_ = vala_binary_expression_get_right (self);
		_tmp6_ = _tmp5_;
		_tmp7_ = sym;
		_tmp8_ = vala_expression_is_accessible (_tmp6_, _tmp7_);
		_tmp0_ = _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gpointer _vala_code_node_ref0 (gpointer self) {
	return self ? vala_code_node_ref (self) : NULL;
}


static gboolean vala_binary_expression_real_check (ValaCodeNode* base, ValaCodeContext* context) {
	ValaBinaryExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_ = FALSE;
	ValaCodeContext* _tmp5_;
	ValaSemanticAnalyzer* _tmp6_;
	ValaSemanticAnalyzer* _tmp7_;
	ValaSymbol* _tmp8_;
	ValaSymbol* _tmp9_;
	ValaBinaryOperator _tmp134_;
	gboolean _tmp339_ = FALSE;
	ValaExpression* _tmp340_;
	ValaExpression* _tmp341_;
	ValaCodeContext* _tmp342_;
	gboolean _tmp343_;
	ValaExpression* _tmp348_;
	ValaExpression* _tmp349_;
	ValaDataType* _tmp350_;
	ValaDataType* _tmp351_;
	gboolean _tmp356_ = FALSE;
	ValaBinaryOperator _tmp357_;
	ValaExpression* _tmp366_;
	ValaExpression* _tmp367_;
	ValaDataType* _tmp368_;
	ValaDataType* _tmp369_;
	ValaExpression* _tmp382_;
	ValaExpression* _tmp383_;
	ValaDataType* _tmp384_;
	ValaDataType* _tmp385_;
	ValaExpression* _tmp398_;
	ValaExpression* _tmp399_;
	ValaExpression* _tmp400_;
	ValaExpression* _tmp401_;
	ValaDataType* _tmp402_;
	ValaDataType* _tmp403_;
	ValaDataType* _tmp404_;
	ValaDataType* _tmp405_;
	ValaExpression* _tmp406_;
	ValaExpression* _tmp407_;
	ValaDataType* _tmp408_;
	ValaDataType* _tmp409_;
	ValaExpression* _tmp410_;
	ValaExpression* _tmp411_;
	ValaExpression* _tmp412_;
	ValaExpression* _tmp413_;
	ValaDataType* _tmp414_;
	ValaDataType* _tmp415_;
	ValaDataType* _tmp416_;
	ValaDataType* _tmp417_;
	ValaExpression* _tmp418_;
	ValaExpression* _tmp419_;
	ValaDataType* _tmp420_;
	ValaDataType* _tmp421_;
	gboolean _tmp422_ = FALSE;
	ValaExpression* _tmp423_;
	ValaExpression* _tmp424_;
	ValaDataType* _tmp425_;
	ValaDataType* _tmp426_;
	ValaTypeSymbol* _tmp427_;
	ValaTypeSymbol* _tmp428_;
	ValaCodeContext* _tmp429_;
	ValaSemanticAnalyzer* _tmp430_;
	ValaSemanticAnalyzer* _tmp431_;
	ValaDataType* _tmp432_;
	ValaTypeSymbol* _tmp433_;
	ValaTypeSymbol* _tmp434_;
	gboolean _tmp1023_;
	gboolean _tmp1024_;
	self = (ValaBinaryExpression*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp5_ = context;
	_tmp6_ = vala_code_context_get_analyzer (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = vala_semantic_analyzer_get_current_symbol (_tmp7_);
	_tmp9_ = _tmp8_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, VALA_TYPE_BLOCK)) {
		gboolean _tmp10_ = FALSE;
		ValaBinaryOperator _tmp11_;
		_tmp11_ = self->priv->_operator;
		if (_tmp11_ == VALA_BINARY_OPERATOR_AND) {
			_tmp10_ = TRUE;
		} else {
			ValaBinaryOperator _tmp12_;
			_tmp12_ = self->priv->_operator;
			_tmp10_ = _tmp12_ == VALA_BINARY_OPERATOR_OR;
		}
		_tmp4_ = _tmp10_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		ValaLocalVariable* local = NULL;
		ValaCodeContext* _tmp13_;
		ValaSemanticAnalyzer* _tmp14_;
		ValaSemanticAnalyzer* _tmp15_;
		ValaDataType* _tmp16_;
		ValaDataType* _tmp17_;
		ValaDataType* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		ValaSourceReference* _tmp21_;
		ValaSourceReference* _tmp22_;
		ValaLocalVariable* _tmp23_;
		ValaLocalVariable* _tmp24_;
		ValaDeclarationStatement* decl = NULL;
		ValaLocalVariable* _tmp25_;
		ValaSourceReference* _tmp26_;
		ValaSourceReference* _tmp27_;
		ValaDeclarationStatement* _tmp28_;
		ValaDeclarationStatement* _tmp29_;
		ValaCodeContext* _tmp30_;
		ValaExpressionStatement* right_stmt = NULL;
		ValaLocalVariable* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		ValaExpression* _tmp34_;
		ValaExpression* _tmp35_;
		ValaSourceReference* _tmp36_;
		ValaSourceReference* _tmp37_;
		ValaMemberAccess* _tmp38_;
		ValaMemberAccess* _tmp39_;
		ValaExpression* _tmp40_;
		ValaExpression* _tmp41_;
		ValaExpression* _tmp42_;
		ValaExpression* _tmp43_;
		ValaSourceReference* _tmp44_;
		ValaSourceReference* _tmp45_;
		ValaAssignment* _tmp46_;
		ValaAssignment* _tmp47_;
		ValaExpression* _tmp48_;
		ValaExpression* _tmp49_;
		ValaSourceReference* _tmp50_;
		ValaSourceReference* _tmp51_;
		ValaExpressionStatement* _tmp52_;
		ValaExpressionStatement* _tmp53_;
		ValaExpressionStatement* stmt = NULL;
		ValaLocalVariable* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		ValaExpression* _tmp57_;
		ValaExpression* _tmp58_;
		ValaSourceReference* _tmp59_;
		ValaSourceReference* _tmp60_;
		ValaMemberAccess* _tmp61_;
		ValaMemberAccess* _tmp62_;
		ValaBinaryOperator _tmp63_;
		ValaExpression* _tmp64_;
		ValaExpression* _tmp65_;
		ValaSourceReference* _tmp66_;
		ValaSourceReference* _tmp67_;
		ValaBooleanLiteral* _tmp68_;
		ValaBooleanLiteral* _tmp69_;
		ValaExpression* _tmp70_;
		ValaExpression* _tmp71_;
		ValaSourceReference* _tmp72_;
		ValaSourceReference* _tmp73_;
		ValaAssignment* _tmp74_;
		ValaAssignment* _tmp75_;
		ValaExpression* _tmp76_;
		ValaExpression* _tmp77_;
		ValaSourceReference* _tmp78_;
		ValaSourceReference* _tmp79_;
		ValaExpressionStatement* _tmp80_;
		ValaExpressionStatement* _tmp81_;
		ValaBlock* true_block = NULL;
		ValaSourceReference* _tmp82_;
		ValaSourceReference* _tmp83_;
		ValaBlock* _tmp84_;
		ValaBlock* false_block = NULL;
		ValaSourceReference* _tmp85_;
		ValaSourceReference* _tmp86_;
		ValaBlock* _tmp87_;
		ValaBinaryOperator _tmp88_;
		ValaIfStatement* if_stmt = NULL;
		ValaExpression* _tmp97_;
		ValaExpression* _tmp98_;
		ValaBlock* _tmp99_;
		ValaBlock* _tmp100_;
		ValaSourceReference* _tmp101_;
		ValaSourceReference* _tmp102_;
		ValaIfStatement* _tmp103_;
		ValaCodeContext* _tmp104_;
		ValaSemanticAnalyzer* _tmp105_;
		ValaSemanticAnalyzer* _tmp106_;
		ValaBlock* _tmp107_;
		ValaDeclarationStatement* _tmp108_;
		ValaCodeContext* _tmp109_;
		ValaSemanticAnalyzer* _tmp110_;
		ValaSemanticAnalyzer* _tmp111_;
		ValaBlock* _tmp112_;
		ValaIfStatement* _tmp113_;
		ValaIfStatement* _tmp114_;
		ValaCodeContext* _tmp115_;
		gboolean _tmp116_;
		ValaMemberAccess* ma = NULL;
		ValaLocalVariable* _tmp117_;
		const gchar* _tmp118_;
		const gchar* _tmp119_;
		ValaSourceReference* _tmp120_;
		ValaSourceReference* _tmp121_;
		ValaMemberAccess* _tmp122_;
		ValaMemberAccess* _tmp123_;
		ValaDataType* _tmp124_;
		ValaDataType* _tmp125_;
		ValaMemberAccess* _tmp126_;
		ValaDataType* _tmp127_;
		ValaDataType* _tmp128_;
		ValaMemberAccess* _tmp129_;
		ValaCodeContext* _tmp130_;
		ValaCodeNode* _tmp131_;
		ValaCodeNode* _tmp132_;
		ValaMemberAccess* _tmp133_;
		_tmp13_ = context;
		_tmp14_ = vala_code_context_get_analyzer (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_->bool_type;
		_tmp17_ = vala_data_type_copy (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = vala_code_node_get_temp_name ();
		_tmp20_ = _tmp19_;
		_tmp21_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp22_ = _tmp21_;
		_tmp23_ = vala_local_variable_new (_tmp18_, _tmp20_, NULL, _tmp22_);
		_tmp24_ = _tmp23_;
		_g_free0 (_tmp20_);
		_vala_code_node_unref0 (_tmp18_);
		local = _tmp24_;
		_tmp25_ = local;
		_tmp26_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp27_ = _tmp26_;
		_tmp28_ = vala_declaration_statement_new ((ValaSymbol*) _tmp25_, _tmp27_);
		decl = _tmp28_;
		_tmp29_ = decl;
		_tmp30_ = context;
		vala_code_node_check ((ValaCodeNode*) _tmp29_, _tmp30_);
		_tmp31_ = local;
		_tmp32_ = vala_symbol_get_name ((ValaSymbol*) _tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = vala_binary_expression_get_right (self);
		_tmp35_ = _tmp34_;
		_tmp36_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = vala_member_access_new_simple (_tmp33_, _tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = vala_binary_expression_get_right (self);
		_tmp41_ = _tmp40_;
		_tmp42_ = vala_binary_expression_get_right (self);
		_tmp43_ = _tmp42_;
		_tmp44_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp43_);
		_tmp45_ = _tmp44_;
		_tmp46_ = vala_assignment_new ((ValaExpression*) _tmp39_, _tmp41_, VALA_ASSIGNMENT_OPERATOR_SIMPLE, _tmp45_);
		_tmp47_ = _tmp46_;
		_tmp48_ = vala_binary_expression_get_right (self);
		_tmp49_ = _tmp48_;
		_tmp50_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = vala_expression_statement_new ((ValaExpression*) _tmp47_, _tmp51_);
		_tmp53_ = _tmp52_;
		_vala_code_node_unref0 (_tmp47_);
		_vala_code_node_unref0 (_tmp39_);
		right_stmt = _tmp53_;
		_tmp54_ = local;
		_tmp55_ = vala_symbol_get_name ((ValaSymbol*) _tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = vala_binary_expression_get_left (self);
		_tmp58_ = _tmp57_;
		_tmp59_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp58_);
		_tmp60_ = _tmp59_;
		_tmp61_ = vala_member_access_new_simple (_tmp56_, _tmp60_);
		_tmp62_ = _tmp61_;
		_tmp63_ = self->priv->_operator;
		_tmp64_ = vala_binary_expression_get_left (self);
		_tmp65_ = _tmp64_;
		_tmp66_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp65_);
		_tmp67_ = _tmp66_;
		_tmp68_ = vala_boolean_literal_new (_tmp63_ == VALA_BINARY_OPERATOR_OR, _tmp67_);
		_tmp69_ = _tmp68_;
		_tmp70_ = vala_binary_expression_get_left (self);
		_tmp71_ = _tmp70_;
		_tmp72_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp71_);
		_tmp73_ = _tmp72_;
		_tmp74_ = vala_assignment_new ((ValaExpression*) _tmp62_, (ValaExpression*) _tmp69_, VALA_ASSIGNMENT_OPERATOR_SIMPLE, _tmp73_);
		_tmp75_ = _tmp74_;
		_tmp76_ = vala_binary_expression_get_left (self);
		_tmp77_ = _tmp76_;
		_tmp78_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp77_);
		_tmp79_ = _tmp78_;
		_tmp80_ = vala_expression_statement_new ((ValaExpression*) _tmp75_, _tmp79_);
		_tmp81_ = _tmp80_;
		_vala_code_node_unref0 (_tmp75_);
		_vala_code_node_unref0 (_tmp69_);
		_vala_code_node_unref0 (_tmp62_);
		stmt = _tmp81_;
		_tmp82_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp83_ = _tmp82_;
		_tmp84_ = vala_block_new (_tmp83_);
		true_block = _tmp84_;
		_tmp85_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp86_ = _tmp85_;
		_tmp87_ = vala_block_new (_tmp86_);
		false_block = _tmp87_;
		_tmp88_ = self->priv->_operator;
		if (_tmp88_ == VALA_BINARY_OPERATOR_AND) {
			ValaBlock* _tmp89_;
			ValaExpressionStatement* _tmp90_;
			ValaBlock* _tmp91_;
			ValaExpressionStatement* _tmp92_;
			_tmp89_ = true_block;
			_tmp90_ = right_stmt;
			vala_block_add_statement (_tmp89_, (ValaStatement*) _tmp90_);
			_tmp91_ = false_block;
			_tmp92_ = stmt;
			vala_block_add_statement (_tmp91_, (ValaStatement*) _tmp92_);
		} else {
			ValaBlock* _tmp93_;
			ValaExpressionStatement* _tmp94_;
			ValaBlock* _tmp95_;
			ValaExpressionStatement* _tmp96_;
			_tmp93_ = true_block;
			_tmp94_ = stmt;
			vala_block_add_statement (_tmp93_, (ValaStatement*) _tmp94_);
			_tmp95_ = false_block;
			_tmp96_ = right_stmt;
			vala_block_add_statement (_tmp95_, (ValaStatement*) _tmp96_);
		}
		_tmp97_ = vala_binary_expression_get_left (self);
		_tmp98_ = _tmp97_;
		_tmp99_ = true_block;
		_tmp100_ = false_block;
		_tmp101_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp102_ = _tmp101_;
		_tmp103_ = vala_if_statement_new (_tmp98_, _tmp99_, _tmp100_, _tmp102_);
		if_stmt = _tmp103_;
		_tmp104_ = context;
		_tmp105_ = vala_code_context_get_analyzer (_tmp104_);
		_tmp106_ = _tmp105_;
		_tmp107_ = _tmp106_->insert_block;
		_tmp108_ = decl;
		vala_expression_insert_statement ((ValaExpression*) self, _tmp107_, (ValaStatement*) _tmp108_);
		_tmp109_ = context;
		_tmp110_ = vala_code_context_get_analyzer (_tmp109_);
		_tmp111_ = _tmp110_;
		_tmp112_ = _tmp111_->insert_block;
		_tmp113_ = if_stmt;
		vala_expression_insert_statement ((ValaExpression*) self, _tmp112_, (ValaStatement*) _tmp113_);
		_tmp114_ = if_stmt;
		_tmp115_ = context;
		_tmp116_ = vala_code_node_check ((ValaCodeNode*) _tmp114_, _tmp115_);
		if (!_tmp116_) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			_vala_code_node_unref0 (if_stmt);
			_vala_code_node_unref0 (false_block);
			_vala_code_node_unref0 (true_block);
			_vala_code_node_unref0 (stmt);
			_vala_code_node_unref0 (right_stmt);
			_vala_code_node_unref0 (decl);
			_vala_code_node_unref0 (local);
			return result;
		}
		_tmp117_ = local;
		_tmp118_ = vala_symbol_get_name ((ValaSymbol*) _tmp117_);
		_tmp119_ = _tmp118_;
		_tmp120_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp121_ = _tmp120_;
		_tmp122_ = vala_member_access_new_simple (_tmp119_, _tmp121_);
		ma = _tmp122_;
		_tmp123_ = ma;
		_tmp124_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp125_ = _tmp124_;
		vala_expression_set_target_type ((ValaExpression*) _tmp123_, _tmp125_);
		_tmp126_ = ma;
		_tmp127_ = vala_expression_get_formal_target_type ((ValaExpression*) self);
		_tmp128_ = _tmp127_;
		vala_expression_set_formal_target_type ((ValaExpression*) _tmp126_, _tmp128_);
		_tmp129_ = ma;
		_tmp130_ = context;
		vala_code_node_check ((ValaCodeNode*) _tmp129_, _tmp130_);
		_tmp131_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
		_tmp132_ = _tmp131_;
		_tmp133_ = ma;
		vala_code_node_replace_expression (_tmp132_, (ValaExpression*) self, (ValaExpression*) _tmp133_);
		result = TRUE;
		_vala_code_node_unref0 (ma);
		_vala_code_node_unref0 (if_stmt);
		_vala_code_node_unref0 (false_block);
		_vala_code_node_unref0 (true_block);
		_vala_code_node_unref0 (stmt);
		_vala_code_node_unref0 (right_stmt);
		_vala_code_node_unref0 (decl);
		_vala_code_node_unref0 (local);
		return result;
	}
	_tmp134_ = self->priv->_operator;
	if (_tmp134_ == VALA_BINARY_OPERATOR_COALESCE) {
		ValaExpression* _tmp135_;
		ValaExpression* _tmp136_;
		ValaCodeContext* _tmp137_;
		gboolean _tmp138_;
		ValaExpression* _tmp139_;
		ValaExpression* _tmp140_;
		ValaCodeContext* _tmp141_;
		gboolean _tmp142_;
		ValaDataType* local_type = NULL;
		gboolean cast_non_null = FALSE;
		gboolean _tmp143_ = FALSE;
		ValaExpression* _tmp144_;
		ValaExpression* _tmp145_;
		ValaDataType* _tmp146_;
		ValaDataType* _tmp147_;
		ValaLocalVariable* local = NULL;
		ValaDataType* _tmp231_;
		gchar* _tmp232_;
		gchar* _tmp233_;
		ValaExpression* _tmp234_;
		ValaExpression* _tmp235_;
		ValaSourceReference* _tmp236_;
		ValaSourceReference* _tmp237_;
		ValaLocalVariable* _tmp238_;
		ValaLocalVariable* _tmp239_;
		ValaDeclarationStatement* decl = NULL;
		ValaLocalVariable* _tmp240_;
		ValaSourceReference* _tmp241_;
		ValaSourceReference* _tmp242_;
		ValaDeclarationStatement* _tmp243_;
		ValaExpressionStatement* right_stmt = NULL;
		ValaLocalVariable* _tmp244_;
		const gchar* _tmp245_;
		const gchar* _tmp246_;
		ValaExpression* _tmp247_;
		ValaExpression* _tmp248_;
		ValaSourceReference* _tmp249_;
		ValaSourceReference* _tmp250_;
		ValaMemberAccess* _tmp251_;
		ValaMemberAccess* _tmp252_;
		ValaExpression* _tmp253_;
		ValaExpression* _tmp254_;
		ValaExpression* _tmp255_;
		ValaExpression* _tmp256_;
		ValaSourceReference* _tmp257_;
		ValaSourceReference* _tmp258_;
		ValaAssignment* _tmp259_;
		ValaAssignment* _tmp260_;
		ValaExpression* _tmp261_;
		ValaExpression* _tmp262_;
		ValaSourceReference* _tmp263_;
		ValaSourceReference* _tmp264_;
		ValaExpressionStatement* _tmp265_;
		ValaExpressionStatement* _tmp266_;
		ValaBlock* true_block = NULL;
		ValaSourceReference* _tmp267_;
		ValaSourceReference* _tmp268_;
		ValaBlock* _tmp269_;
		ValaBlock* _tmp270_;
		ValaExpressionStatement* _tmp271_;
		ValaBinaryExpression* cond = NULL;
		ValaLocalVariable* _tmp272_;
		const gchar* _tmp273_;
		const gchar* _tmp274_;
		ValaExpression* _tmp275_;
		ValaExpression* _tmp276_;
		ValaSourceReference* _tmp277_;
		ValaSourceReference* _tmp278_;
		ValaMemberAccess* _tmp279_;
		ValaMemberAccess* _tmp280_;
		ValaSourceReference* _tmp281_;
		ValaSourceReference* _tmp282_;
		ValaNullLiteral* _tmp283_;
		ValaNullLiteral* _tmp284_;
		ValaSourceReference* _tmp285_;
		ValaSourceReference* _tmp286_;
		ValaBinaryExpression* _tmp287_;
		ValaBinaryExpression* _tmp288_;
		ValaIfStatement* if_stmt = NULL;
		ValaBinaryExpression* _tmp289_;
		ValaBlock* _tmp290_;
		ValaSourceReference* _tmp291_;
		ValaSourceReference* _tmp292_;
		ValaIfStatement* _tmp293_;
		ValaCodeContext* _tmp294_;
		ValaSemanticAnalyzer* _tmp295_;
		ValaSemanticAnalyzer* _tmp296_;
		ValaBlock* _tmp297_;
		ValaDeclarationStatement* _tmp298_;
		ValaCodeContext* _tmp299_;
		ValaSemanticAnalyzer* _tmp300_;
		ValaSemanticAnalyzer* _tmp301_;
		ValaBlock* _tmp302_;
		ValaIfStatement* _tmp303_;
		ValaDeclarationStatement* _tmp304_;
		ValaCodeContext* _tmp305_;
		gboolean _tmp306_;
		ValaIfStatement* _tmp307_;
		ValaCodeContext* _tmp308_;
		gboolean _tmp309_;
		ValaExpression* replace_expr = NULL;
		ValaLocalVariable* _tmp310_;
		ValaDataType* _tmp311_;
		ValaDataType* _tmp312_;
		ValaExpression* _tmp313_;
		gboolean _tmp314_ = FALSE;
		gboolean _tmp315_;
		ValaExpression* _tmp334_;
		ValaCodeContext* _tmp335_;
		ValaCodeNode* _tmp336_;
		ValaCodeNode* _tmp337_;
		ValaExpression* _tmp338_;
		_tmp135_ = vala_binary_expression_get_left (self);
		_tmp136_ = _tmp135_;
		_tmp137_ = context;
		_tmp138_ = vala_code_node_check ((ValaCodeNode*) _tmp136_, _tmp137_);
		if (!_tmp138_) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			return result;
		}
		_tmp139_ = vala_binary_expression_get_right (self);
		_tmp140_ = _tmp139_;
		_tmp141_ = context;
		_tmp142_ = vala_code_node_check ((ValaCodeNode*) _tmp140_, _tmp141_);
		if (!_tmp142_) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			return result;
		}
		local_type = NULL;
		cast_non_null = FALSE;
		_tmp144_ = vala_binary_expression_get_left (self);
		_tmp145_ = _tmp144_;
		_tmp146_ = vala_expression_get_value_type (_tmp145_);
		_tmp147_ = _tmp146_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp147_, VALA_TYPE_NULL_TYPE)) {
			ValaExpression* _tmp148_;
			ValaExpression* _tmp149_;
			ValaDataType* _tmp150_;
			ValaDataType* _tmp151_;
			_tmp148_ = vala_binary_expression_get_right (self);
			_tmp149_ = _tmp148_;
			_tmp150_ = vala_expression_get_value_type (_tmp149_);
			_tmp151_ = _tmp150_;
			_tmp143_ = _tmp151_ != NULL;
		} else {
			_tmp143_ = FALSE;
		}
		if (_tmp143_) {
			ValaExpression* _tmp152_;
			ValaExpression* _tmp153_;
			ValaSourceReference* _tmp154_;
			ValaSourceReference* _tmp155_;
			ValaExpression* _tmp156_;
			ValaExpression* _tmp157_;
			ValaDataType* _tmp158_;
			ValaDataType* _tmp159_;
			ValaDataType* _tmp160_;
			ValaDataType* _tmp161_;
			ValaExpression* _tmp162_;
			ValaExpression* _tmp163_;
			ValaDataType* _tmp164_;
			ValaDataType* _tmp165_;
			gboolean _tmp166_;
			gboolean _tmp167_;
			_tmp152_ = vala_binary_expression_get_left (self);
			_tmp153_ = _tmp152_;
			_tmp154_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp153_);
			_tmp155_ = _tmp154_;
			vala_report_warning (_tmp155_, "left operand is always null");
			_tmp156_ = vala_binary_expression_get_right (self);
			_tmp157_ = _tmp156_;
			_tmp158_ = vala_expression_get_value_type (_tmp157_);
			_tmp159_ = _tmp158_;
			_tmp160_ = vala_data_type_copy (_tmp159_);
			_vala_code_node_unref0 (local_type);
			local_type = _tmp160_;
			_tmp161_ = local_type;
			vala_data_type_set_nullable (_tmp161_, TRUE);
			_tmp162_ = vala_binary_expression_get_right (self);
			_tmp163_ = _tmp162_;
			_tmp164_ = vala_expression_get_value_type (_tmp163_);
			_tmp165_ = _tmp164_;
			_tmp166_ = vala_data_type_get_nullable (_tmp165_);
			_tmp167_ = _tmp166_;
			if (!_tmp167_) {
				cast_non_null = TRUE;
			}
		} else {
			ValaExpression* _tmp168_;
			ValaExpression* _tmp169_;
			ValaDataType* _tmp170_;
			ValaDataType* _tmp171_;
			_tmp168_ = vala_binary_expression_get_left (self);
			_tmp169_ = _tmp168_;
			_tmp170_ = vala_expression_get_value_type (_tmp169_);
			_tmp171_ = _tmp170_;
			if (_tmp171_ != NULL) {
				ValaExpression* _tmp172_;
				ValaExpression* _tmp173_;
				ValaDataType* _tmp174_;
				ValaDataType* _tmp175_;
				ValaDataType* _tmp176_;
				gboolean _tmp177_ = FALSE;
				ValaExpression* _tmp178_;
				ValaExpression* _tmp179_;
				ValaDataType* _tmp180_;
				ValaDataType* _tmp181_;
				ValaCodeContext* _tmp189_;
				gboolean _tmp190_;
				gboolean _tmp191_;
				_tmp172_ = vala_binary_expression_get_left (self);
				_tmp173_ = _tmp172_;
				_tmp174_ = vala_expression_get_value_type (_tmp173_);
				_tmp175_ = _tmp174_;
				_tmp176_ = vala_data_type_copy (_tmp175_);
				_vala_code_node_unref0 (local_type);
				local_type = _tmp176_;
				_tmp178_ = vala_binary_expression_get_right (self);
				_tmp179_ = _tmp178_;
				_tmp180_ = vala_expression_get_value_type (_tmp179_);
				_tmp181_ = _tmp180_;
				if (_tmp181_ != NULL) {
					ValaExpression* _tmp182_;
					ValaExpression* _tmp183_;
					ValaDataType* _tmp184_;
					ValaDataType* _tmp185_;
					gboolean _tmp186_;
					gboolean _tmp187_;
					_tmp182_ = vala_binary_expression_get_right (self);
					_tmp183_ = _tmp182_;
					_tmp184_ = vala_expression_get_value_type (_tmp183_);
					_tmp185_ = _tmp184_;
					_tmp186_ = vala_data_type_get_value_owned (_tmp185_);
					_tmp187_ = _tmp186_;
					_tmp177_ = _tmp187_;
				} else {
					_tmp177_ = FALSE;
				}
				if (_tmp177_) {
					ValaDataType* _tmp188_;
					_tmp188_ = local_type;
					vala_data_type_set_value_owned (_tmp188_, TRUE);
				}
				_tmp189_ = context;
				_tmp190_ = vala_code_context_get_experimental_non_null (_tmp189_);
				_tmp191_ = _tmp190_;
				if (_tmp191_) {
					ValaDataType* _tmp192_;
					gboolean _tmp193_;
					gboolean _tmp194_;
					_tmp192_ = local_type;
					_tmp193_ = vala_data_type_get_nullable (_tmp192_);
					_tmp194_ = _tmp193_;
					if (!_tmp194_) {
						ValaExpression* _tmp195_;
						ValaExpression* _tmp196_;
						ValaSourceReference* _tmp197_;
						ValaSourceReference* _tmp198_;
						gboolean _tmp199_ = FALSE;
						ValaExpression* _tmp200_;
						ValaExpression* _tmp201_;
						ValaDataType* _tmp202_;
						ValaDataType* _tmp203_;
						_tmp195_ = vala_binary_expression_get_left (self);
						_tmp196_ = _tmp195_;
						_tmp197_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp196_);
						_tmp198_ = _tmp197_;
						vala_report_warning (_tmp198_, "left operand is never null");
						_tmp200_ = vala_binary_expression_get_right (self);
						_tmp201_ = _tmp200_;
						_tmp202_ = vala_expression_get_value_type (_tmp201_);
						_tmp203_ = _tmp202_;
						if (_tmp203_ != NULL) {
							ValaExpression* _tmp204_;
							ValaExpression* _tmp205_;
							ValaDataType* _tmp206_;
							ValaDataType* _tmp207_;
							gboolean _tmp208_;
							gboolean _tmp209_;
							_tmp204_ = vala_binary_expression_get_right (self);
							_tmp205_ = _tmp204_;
							_tmp206_ = vala_expression_get_value_type (_tmp205_);
							_tmp207_ = _tmp206_;
							_tmp208_ = vala_data_type_get_nullable (_tmp207_);
							_tmp209_ = _tmp208_;
							_tmp199_ = _tmp209_;
						} else {
							_tmp199_ = FALSE;
						}
						if (_tmp199_) {
							ValaDataType* _tmp210_;
							_tmp210_ = local_type;
							vala_data_type_set_nullable (_tmp210_, TRUE);
							cast_non_null = TRUE;
						}
					} else {
						gboolean _tmp211_ = FALSE;
						ValaExpression* _tmp212_;
						ValaExpression* _tmp213_;
						ValaDataType* _tmp214_;
						ValaDataType* _tmp215_;
						_tmp212_ = vala_binary_expression_get_right (self);
						_tmp213_ = _tmp212_;
						_tmp214_ = vala_expression_get_value_type (_tmp213_);
						_tmp215_ = _tmp214_;
						if (_tmp215_ != NULL) {
							ValaExpression* _tmp216_;
							ValaExpression* _tmp217_;
							ValaDataType* _tmp218_;
							ValaDataType* _tmp219_;
							gboolean _tmp220_;
							gboolean _tmp221_;
							_tmp216_ = vala_binary_expression_get_right (self);
							_tmp217_ = _tmp216_;
							_tmp218_ = vala_expression_get_value_type (_tmp217_);
							_tmp219_ = _tmp218_;
							_tmp220_ = vala_data_type_get_nullable (_tmp219_);
							_tmp221_ = _tmp220_;
							_tmp211_ = !_tmp221_;
						} else {
							_tmp211_ = FALSE;
						}
						if (_tmp211_) {
							cast_non_null = TRUE;
						}
					}
				}
			} else {
				ValaExpression* _tmp222_;
				ValaExpression* _tmp223_;
				ValaDataType* _tmp224_;
				ValaDataType* _tmp225_;
				_tmp222_ = vala_binary_expression_get_right (self);
				_tmp223_ = _tmp222_;
				_tmp224_ = vala_expression_get_value_type (_tmp223_);
				_tmp225_ = _tmp224_;
				if (_tmp225_ != NULL) {
					ValaExpression* _tmp226_;
					ValaExpression* _tmp227_;
					ValaDataType* _tmp228_;
					ValaDataType* _tmp229_;
					ValaDataType* _tmp230_;
					_tmp226_ = vala_binary_expression_get_right (self);
					_tmp227_ = _tmp226_;
					_tmp228_ = vala_expression_get_value_type (_tmp227_);
					_tmp229_ = _tmp228_;
					_tmp230_ = vala_data_type_copy (_tmp229_);
					_vala_code_node_unref0 (local_type);
					local_type = _tmp230_;
				}
			}
		}
		_tmp231_ = local_type;
		_tmp232_ = vala_code_node_get_temp_name ();
		_tmp233_ = _tmp232_;
		_tmp234_ = vala_binary_expression_get_left (self);
		_tmp235_ = _tmp234_;
		_tmp236_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp237_ = _tmp236_;
		_tmp238_ = vala_local_variable_new (_tmp231_, _tmp233_, _tmp235_, _tmp237_);
		_tmp239_ = _tmp238_;
		_g_free0 (_tmp233_);
		local = _tmp239_;
		_tmp240_ = local;
		_tmp241_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp242_ = _tmp241_;
		_tmp243_ = vala_declaration_statement_new ((ValaSymbol*) _tmp240_, _tmp242_);
		decl = _tmp243_;
		_tmp244_ = local;
		_tmp245_ = vala_symbol_get_name ((ValaSymbol*) _tmp244_);
		_tmp246_ = _tmp245_;
		_tmp247_ = vala_binary_expression_get_right (self);
		_tmp248_ = _tmp247_;
		_tmp249_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp248_);
		_tmp250_ = _tmp249_;
		_tmp251_ = vala_member_access_new_simple (_tmp246_, _tmp250_);
		_tmp252_ = _tmp251_;
		_tmp253_ = vala_binary_expression_get_right (self);
		_tmp254_ = _tmp253_;
		_tmp255_ = vala_binary_expression_get_right (self);
		_tmp256_ = _tmp255_;
		_tmp257_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp256_);
		_tmp258_ = _tmp257_;
		_tmp259_ = vala_assignment_new ((ValaExpression*) _tmp252_, _tmp254_, VALA_ASSIGNMENT_OPERATOR_SIMPLE, _tmp258_);
		_tmp260_ = _tmp259_;
		_tmp261_ = vala_binary_expression_get_right (self);
		_tmp262_ = _tmp261_;
		_tmp263_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp262_);
		_tmp264_ = _tmp263_;
		_tmp265_ = vala_expression_statement_new ((ValaExpression*) _tmp260_, _tmp264_);
		_tmp266_ = _tmp265_;
		_vala_code_node_unref0 (_tmp260_);
		_vala_code_node_unref0 (_tmp252_);
		right_stmt = _tmp266_;
		_tmp267_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp268_ = _tmp267_;
		_tmp269_ = vala_block_new (_tmp268_);
		true_block = _tmp269_;
		_tmp270_ = true_block;
		_tmp271_ = right_stmt;
		vala_block_add_statement (_tmp270_, (ValaStatement*) _tmp271_);
		_tmp272_ = local;
		_tmp273_ = vala_symbol_get_name ((ValaSymbol*) _tmp272_);
		_tmp274_ = _tmp273_;
		_tmp275_ = vala_binary_expression_get_left (self);
		_tmp276_ = _tmp275_;
		_tmp277_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp276_);
		_tmp278_ = _tmp277_;
		_tmp279_ = vala_member_access_new_simple (_tmp274_, _tmp278_);
		_tmp280_ = _tmp279_;
		_tmp281_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp282_ = _tmp281_;
		_tmp283_ = vala_null_literal_new (_tmp282_);
		_tmp284_ = _tmp283_;
		_tmp285_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp286_ = _tmp285_;
		_tmp287_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_EQUALITY, (ValaExpression*) _tmp280_, (ValaExpression*) _tmp284_, _tmp286_);
		_tmp288_ = _tmp287_;
		_vala_code_node_unref0 (_tmp284_);
		_vala_code_node_unref0 (_tmp280_);
		cond = _tmp288_;
		_tmp289_ = cond;
		_tmp290_ = true_block;
		_tmp291_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp292_ = _tmp291_;
		_tmp293_ = vala_if_statement_new ((ValaExpression*) _tmp289_, _tmp290_, NULL, _tmp292_);
		if_stmt = _tmp293_;
		_tmp294_ = context;
		_tmp295_ = vala_code_context_get_analyzer (_tmp294_);
		_tmp296_ = _tmp295_;
		_tmp297_ = _tmp296_->insert_block;
		_tmp298_ = decl;
		vala_expression_insert_statement ((ValaExpression*) self, _tmp297_, (ValaStatement*) _tmp298_);
		_tmp299_ = context;
		_tmp300_ = vala_code_context_get_analyzer (_tmp299_);
		_tmp301_ = _tmp300_;
		_tmp302_ = _tmp301_->insert_block;
		_tmp303_ = if_stmt;
		vala_expression_insert_statement ((ValaExpression*) self, _tmp302_, (ValaStatement*) _tmp303_);
		_tmp304_ = decl;
		_tmp305_ = context;
		_tmp306_ = vala_code_node_check ((ValaCodeNode*) _tmp304_, _tmp305_);
		if (!_tmp306_) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			_vala_code_node_unref0 (if_stmt);
			_vala_code_node_unref0 (cond);
			_vala_code_node_unref0 (true_block);
			_vala_code_node_unref0 (right_stmt);
			_vala_code_node_unref0 (decl);
			_vala_code_node_unref0 (local);
			_vala_code_node_unref0 (local_type);
			return result;
		}
		_tmp307_ = if_stmt;
		_tmp308_ = context;
		_tmp309_ = vala_code_node_check ((ValaCodeNode*) _tmp307_, _tmp308_);
		if (!_tmp309_) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			_vala_code_node_unref0 (if_stmt);
			_vala_code_node_unref0 (cond);
			_vala_code_node_unref0 (true_block);
			_vala_code_node_unref0 (right_stmt);
			_vala_code_node_unref0 (decl);
			_vala_code_node_unref0 (local);
			_vala_code_node_unref0 (local_type);
			return result;
		}
		_tmp310_ = local;
		_tmp311_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp312_ = _tmp311_;
		_tmp313_ = vala_semantic_analyzer_create_temp_access (_tmp310_, _tmp312_);
		replace_expr = _tmp313_;
		_tmp315_ = cast_non_null;
		if (_tmp315_) {
			ValaExpression* _tmp316_;
			ValaDataType* _tmp317_;
			ValaDataType* _tmp318_;
			_tmp316_ = replace_expr;
			_tmp317_ = vala_expression_get_target_type (_tmp316_);
			_tmp318_ = _tmp317_;
			_tmp314_ = _tmp318_ != NULL;
		} else {
			_tmp314_ = FALSE;
		}
		if (_tmp314_) {
			ValaCastExpression* cast = NULL;
			ValaExpression* _tmp319_;
			ValaSourceReference* _tmp320_;
			ValaSourceReference* _tmp321_;
			ValaCastExpression* _tmp322_;
			ValaCastExpression* _tmp323_;
			ValaExpression* _tmp324_;
			ValaDataType* _tmp325_;
			ValaDataType* _tmp326_;
			ValaDataType* _tmp327_;
			ValaDataType* _tmp328_;
			ValaCastExpression* _tmp329_;
			ValaDataType* _tmp330_;
			ValaDataType* _tmp331_;
			ValaCastExpression* _tmp332_;
			ValaExpression* _tmp333_;
			_tmp319_ = replace_expr;
			_tmp320_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp321_ = _tmp320_;
			_tmp322_ = vala_cast_expression_new_non_null (_tmp319_, _tmp321_);
			cast = _tmp322_;
			_tmp323_ = cast;
			_tmp324_ = replace_expr;
			_tmp325_ = vala_expression_get_target_type (_tmp324_);
			_tmp326_ = _tmp325_;
			_tmp327_ = vala_data_type_copy (_tmp326_);
			_tmp328_ = _tmp327_;
			vala_expression_set_target_type ((ValaExpression*) _tmp323_, _tmp328_);
			_vala_code_node_unref0 (_tmp328_);
			_tmp329_ = cast;
			_tmp330_ = vala_expression_get_target_type ((ValaExpression*) _tmp329_);
			_tmp331_ = _tmp330_;
			vala_data_type_set_nullable (_tmp331_, FALSE);
			_tmp332_ = cast;
			_tmp333_ = _vala_code_node_ref0 ((ValaExpression*) _tmp332_);
			_vala_code_node_unref0 (replace_expr);
			replace_expr = _tmp333_;
			_vala_code_node_unref0 (cast);
		}
		_tmp334_ = replace_expr;
		_tmp335_ = context;
		vala_code_node_check ((ValaCodeNode*) _tmp334_, _tmp335_);
		_tmp336_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
		_tmp337_ = _tmp336_;
		_tmp338_ = replace_expr;
		vala_code_node_replace_expression (_tmp337_, (ValaExpression*) self, _tmp338_);
		result = TRUE;
		_vala_code_node_unref0 (replace_expr);
		_vala_code_node_unref0 (if_stmt);
		_vala_code_node_unref0 (cond);
		_vala_code_node_unref0 (true_block);
		_vala_code_node_unref0 (right_stmt);
		_vala_code_node_unref0 (decl);
		_vala_code_node_unref0 (local);
		_vala_code_node_unref0 (local_type);
		return result;
	}
	_tmp340_ = vala_binary_expression_get_left (self);
	_tmp341_ = _tmp340_;
	_tmp342_ = context;
	_tmp343_ = vala_code_node_check ((ValaCodeNode*) _tmp341_, _tmp342_);
	if (!_tmp343_) {
		_tmp339_ = TRUE;
	} else {
		ValaExpression* _tmp344_;
		ValaExpression* _tmp345_;
		ValaCodeContext* _tmp346_;
		gboolean _tmp347_;
		_tmp344_ = vala_binary_expression_get_right (self);
		_tmp345_ = _tmp344_;
		_tmp346_ = context;
		_tmp347_ = vala_code_node_check ((ValaCodeNode*) _tmp345_, _tmp346_);
		_tmp339_ = !_tmp347_;
	}
	if (_tmp339_) {
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp348_ = vala_binary_expression_get_left (self);
	_tmp349_ = _tmp348_;
	_tmp350_ = vala_expression_get_value_type (_tmp349_);
	_tmp351_ = _tmp350_;
	if (_tmp351_ == NULL) {
		ValaExpression* _tmp352_;
		ValaExpression* _tmp353_;
		ValaSourceReference* _tmp354_;
		ValaSourceReference* _tmp355_;
		_tmp352_ = vala_binary_expression_get_left (self);
		_tmp353_ = _tmp352_;
		_tmp354_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp353_);
		_tmp355_ = _tmp354_;
		vala_report_error (_tmp355_, "invalid left operand");
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp357_ = self->priv->_operator;
	if (_tmp357_ != VALA_BINARY_OPERATOR_IN) {
		ValaExpression* _tmp358_;
		ValaExpression* _tmp359_;
		ValaDataType* _tmp360_;
		ValaDataType* _tmp361_;
		_tmp358_ = vala_binary_expression_get_right (self);
		_tmp359_ = _tmp358_;
		_tmp360_ = vala_expression_get_value_type (_tmp359_);
		_tmp361_ = _tmp360_;
		_tmp356_ = _tmp361_ == NULL;
	} else {
		_tmp356_ = FALSE;
	}
	if (_tmp356_) {
		ValaExpression* _tmp362_;
		ValaExpression* _tmp363_;
		ValaSourceReference* _tmp364_;
		ValaSourceReference* _tmp365_;
		_tmp362_ = vala_binary_expression_get_right (self);
		_tmp363_ = _tmp362_;
		_tmp364_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp363_);
		_tmp365_ = _tmp364_;
		vala_report_error (_tmp365_, "invalid right operand");
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp366_ = vala_binary_expression_get_left (self);
	_tmp367_ = _tmp366_;
	_tmp368_ = vala_expression_get_value_type (_tmp367_);
	_tmp369_ = _tmp368_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp369_, VALA_TYPE_FIELD_PROTOTYPE)) {
		ValaExpression* _tmp370_;
		ValaExpression* _tmp371_;
		ValaSourceReference* _tmp372_;
		ValaSourceReference* _tmp373_;
		ValaExpression* _tmp374_;
		ValaExpression* _tmp375_;
		ValaSymbol* _tmp376_;
		ValaSymbol* _tmp377_;
		gchar* _tmp378_;
		gchar* _tmp379_;
		gchar* _tmp380_;
		gchar* _tmp381_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp370_ = vala_binary_expression_get_left (self);
		_tmp371_ = _tmp370_;
		_tmp372_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp371_);
		_tmp373_ = _tmp372_;
		_tmp374_ = vala_binary_expression_get_left (self);
		_tmp375_ = _tmp374_;
		_tmp376_ = vala_expression_get_symbol_reference (_tmp375_);
		_tmp377_ = _tmp376_;
		_tmp378_ = vala_symbol_get_full_name (_tmp377_);
		_tmp379_ = _tmp378_;
		_tmp380_ = g_strdup_printf ("Access to instance member `%s' denied", _tmp379_);
		_tmp381_ = _tmp380_;
		vala_report_error (_tmp373_, _tmp381_);
		_g_free0 (_tmp381_);
		_g_free0 (_tmp379_);
		result = FALSE;
		return result;
	}
	_tmp382_ = vala_binary_expression_get_right (self);
	_tmp383_ = _tmp382_;
	_tmp384_ = vala_expression_get_value_type (_tmp383_);
	_tmp385_ = _tmp384_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp385_, VALA_TYPE_FIELD_PROTOTYPE)) {
		ValaExpression* _tmp386_;
		ValaExpression* _tmp387_;
		ValaSourceReference* _tmp388_;
		ValaSourceReference* _tmp389_;
		ValaExpression* _tmp390_;
		ValaExpression* _tmp391_;
		ValaSymbol* _tmp392_;
		ValaSymbol* _tmp393_;
		gchar* _tmp394_;
		gchar* _tmp395_;
		gchar* _tmp396_;
		gchar* _tmp397_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp386_ = vala_binary_expression_get_right (self);
		_tmp387_ = _tmp386_;
		_tmp388_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp387_);
		_tmp389_ = _tmp388_;
		_tmp390_ = vala_binary_expression_get_right (self);
		_tmp391_ = _tmp390_;
		_tmp392_ = vala_expression_get_symbol_reference (_tmp391_);
		_tmp393_ = _tmp392_;
		_tmp394_ = vala_symbol_get_full_name (_tmp393_);
		_tmp395_ = _tmp394_;
		_tmp396_ = g_strdup_printf ("Access to instance member `%s' denied", _tmp395_);
		_tmp397_ = _tmp396_;
		vala_report_error (_tmp389_, _tmp397_);
		_g_free0 (_tmp397_);
		_g_free0 (_tmp395_);
		result = FALSE;
		return result;
	}
	_tmp398_ = vala_binary_expression_get_left (self);
	_tmp399_ = _tmp398_;
	_tmp400_ = vala_binary_expression_get_left (self);
	_tmp401_ = _tmp400_;
	_tmp402_ = vala_expression_get_value_type (_tmp401_);
	_tmp403_ = _tmp402_;
	_tmp404_ = vala_data_type_copy (_tmp403_);
	_tmp405_ = _tmp404_;
	vala_expression_set_target_type (_tmp399_, _tmp405_);
	_vala_code_node_unref0 (_tmp405_);
	_tmp406_ = vala_binary_expression_get_left (self);
	_tmp407_ = _tmp406_;
	_tmp408_ = vala_expression_get_target_type (_tmp407_);
	_tmp409_ = _tmp408_;
	vala_data_type_set_value_owned (_tmp409_, FALSE);
	_tmp410_ = vala_binary_expression_get_right (self);
	_tmp411_ = _tmp410_;
	_tmp412_ = vala_binary_expression_get_right (self);
	_tmp413_ = _tmp412_;
	_tmp414_ = vala_expression_get_value_type (_tmp413_);
	_tmp415_ = _tmp414_;
	_tmp416_ = vala_data_type_copy (_tmp415_);
	_tmp417_ = _tmp416_;
	vala_expression_set_target_type (_tmp411_, _tmp417_);
	_vala_code_node_unref0 (_tmp417_);
	_tmp418_ = vala_binary_expression_get_right (self);
	_tmp419_ = _tmp418_;
	_tmp420_ = vala_expression_get_target_type (_tmp419_);
	_tmp421_ = _tmp420_;
	vala_data_type_set_value_owned (_tmp421_, FALSE);
	_tmp423_ = vala_binary_expression_get_left (self);
	_tmp424_ = _tmp423_;
	_tmp425_ = vala_expression_get_value_type (_tmp424_);
	_tmp426_ = _tmp425_;
	_tmp427_ = vala_data_type_get_data_type (_tmp426_);
	_tmp428_ = _tmp427_;
	_tmp429_ = context;
	_tmp430_ = vala_code_context_get_analyzer (_tmp429_);
	_tmp431_ = _tmp430_;
	_tmp432_ = _tmp431_->string_type;
	_tmp433_ = vala_data_type_get_data_type (_tmp432_);
	_tmp434_ = _tmp433_;
	if (_tmp428_ == _tmp434_) {
		ValaBinaryOperator _tmp435_;
		_tmp435_ = self->priv->_operator;
		_tmp422_ = _tmp435_ == VALA_BINARY_OPERATOR_PLUS;
	} else {
		_tmp422_ = FALSE;
	}
	if (_tmp422_) {
		gboolean _tmp436_ = FALSE;
		ValaExpression* _tmp437_;
		ValaExpression* _tmp438_;
		ValaDataType* _tmp439_;
		ValaDataType* _tmp440_;
		ValaCodeContext* _tmp455_;
		ValaSemanticAnalyzer* _tmp456_;
		ValaSemanticAnalyzer* _tmp457_;
		ValaDataType* _tmp458_;
		ValaDataType* _tmp459_;
		ValaDataType* _tmp460_;
		gboolean _tmp461_ = FALSE;
		ValaExpression* _tmp462_;
		ValaExpression* _tmp463_;
		gboolean _tmp464_;
		_tmp437_ = vala_binary_expression_get_right (self);
		_tmp438_ = _tmp437_;
		_tmp439_ = vala_expression_get_value_type (_tmp438_);
		_tmp440_ = _tmp439_;
		if (_tmp440_ == NULL) {
			_tmp436_ = TRUE;
		} else {
			ValaExpression* _tmp441_;
			ValaExpression* _tmp442_;
			ValaDataType* _tmp443_;
			ValaDataType* _tmp444_;
			ValaTypeSymbol* _tmp445_;
			ValaTypeSymbol* _tmp446_;
			ValaCodeContext* _tmp447_;
			ValaSemanticAnalyzer* _tmp448_;
			ValaSemanticAnalyzer* _tmp449_;
			ValaDataType* _tmp450_;
			ValaTypeSymbol* _tmp451_;
			ValaTypeSymbol* _tmp452_;
			_tmp441_ = vala_binary_expression_get_right (self);
			_tmp442_ = _tmp441_;
			_tmp443_ = vala_expression_get_value_type (_tmp442_);
			_tmp444_ = _tmp443_;
			_tmp445_ = vala_data_type_get_data_type (_tmp444_);
			_tmp446_ = _tmp445_;
			_tmp447_ = context;
			_tmp448_ = vala_code_context_get_analyzer (_tmp447_);
			_tmp449_ = _tmp448_;
			_tmp450_ = _tmp449_->string_type;
			_tmp451_ = vala_data_type_get_data_type (_tmp450_);
			_tmp452_ = _tmp451_;
			_tmp436_ = _tmp446_ != _tmp452_;
		}
		if (_tmp436_) {
			ValaSourceReference* _tmp453_;
			ValaSourceReference* _tmp454_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp453_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp454_ = _tmp453_;
			vala_report_error (_tmp454_, "Operands must be strings");
			result = FALSE;
			return result;
		}
		_tmp455_ = context;
		_tmp456_ = vala_code_context_get_analyzer (_tmp455_);
		_tmp457_ = _tmp456_;
		_tmp458_ = _tmp457_->string_type;
		_tmp459_ = vala_data_type_copy (_tmp458_);
		_tmp460_ = _tmp459_;
		vala_expression_set_value_type ((ValaExpression*) self, _tmp460_);
		_vala_code_node_unref0 (_tmp460_);
		_tmp462_ = vala_binary_expression_get_left (self);
		_tmp463_ = _tmp462_;
		_tmp464_ = vala_expression_is_constant (_tmp463_);
		if (_tmp464_) {
			ValaExpression* _tmp465_;
			ValaExpression* _tmp466_;
			gboolean _tmp467_;
			_tmp465_ = vala_binary_expression_get_right (self);
			_tmp466_ = _tmp465_;
			_tmp467_ = vala_expression_is_constant (_tmp466_);
			_tmp461_ = _tmp467_;
		} else {
			_tmp461_ = FALSE;
		}
		if (_tmp461_) {
			ValaDataType* _tmp468_;
			ValaDataType* _tmp469_;
			_tmp468_ = vala_expression_get_value_type ((ValaExpression*) self);
			_tmp469_ = _tmp468_;
			vala_data_type_set_value_owned (_tmp469_, FALSE);
		} else {
			ValaDataType* _tmp470_;
			ValaDataType* _tmp471_;
			_tmp470_ = vala_expression_get_value_type ((ValaExpression*) self);
			_tmp471_ = _tmp470_;
			vala_data_type_set_value_owned (_tmp471_, TRUE);
		}
	} else {
		gboolean _tmp472_ = FALSE;
		ValaExpression* _tmp473_;
		ValaExpression* _tmp474_;
		ValaDataType* _tmp475_;
		ValaDataType* _tmp476_;
		_tmp473_ = vala_binary_expression_get_left (self);
		_tmp474_ = _tmp473_;
		_tmp475_ = vala_expression_get_value_type (_tmp474_);
		_tmp476_ = _tmp475_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp476_, VALA_TYPE_ARRAY_TYPE)) {
			ValaBinaryOperator _tmp477_;
			_tmp477_ = self->priv->_operator;
			_tmp472_ = _tmp477_ == VALA_BINARY_OPERATOR_PLUS;
		} else {
			_tmp472_ = FALSE;
		}
		if (_tmp472_) {
			ValaArrayType* array_type = NULL;
			ValaExpression* _tmp478_;
			ValaExpression* _tmp479_;
			ValaDataType* _tmp480_;
			ValaDataType* _tmp481_;
			ValaArrayType* _tmp482_;
			gboolean _tmp483_ = FALSE;
			ValaExpression* _tmp484_;
			ValaExpression* _tmp485_;
			ValaDataType* _tmp486_;
			ValaDataType* _tmp487_;
			ValaExpression* _tmp498_;
			ValaExpression* _tmp499_;
			ValaArrayType* _tmp500_;
			ValaDataType* _tmp501_;
			ValaDataType* _tmp502_;
			ValaDataType* _tmp503_;
			ValaDataType* _tmp504_;
			ValaArrayType* _tmp505_;
			ValaDataType* _tmp506_;
			ValaDataType* _tmp507_;
			ValaDataType* _tmp508_;
			ValaDataType* _tmp509_;
			_tmp478_ = vala_binary_expression_get_left (self);
			_tmp479_ = _tmp478_;
			_tmp480_ = vala_expression_get_value_type (_tmp479_);
			_tmp481_ = _tmp480_;
			_tmp482_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp481_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
			array_type = _tmp482_;
			_tmp484_ = vala_binary_expression_get_right (self);
			_tmp485_ = _tmp484_;
			_tmp486_ = vala_expression_get_value_type (_tmp485_);
			_tmp487_ = _tmp486_;
			if (_tmp487_ == NULL) {
				_tmp483_ = TRUE;
			} else {
				ValaExpression* _tmp488_;
				ValaExpression* _tmp489_;
				ValaDataType* _tmp490_;
				ValaDataType* _tmp491_;
				ValaArrayType* _tmp492_;
				ValaDataType* _tmp493_;
				ValaDataType* _tmp494_;
				gboolean _tmp495_;
				_tmp488_ = vala_binary_expression_get_right (self);
				_tmp489_ = _tmp488_;
				_tmp490_ = vala_expression_get_value_type (_tmp489_);
				_tmp491_ = _tmp490_;
				_tmp492_ = array_type;
				_tmp493_ = vala_array_type_get_element_type (_tmp492_);
				_tmp494_ = _tmp493_;
				_tmp495_ = vala_data_type_compatible (_tmp491_, _tmp494_);
				_tmp483_ = !_tmp495_;
			}
			if (_tmp483_) {
				ValaSourceReference* _tmp496_;
				ValaSourceReference* _tmp497_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp496_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp497_ = _tmp496_;
				vala_report_error (_tmp497_, "Incompatible operand");
				result = FALSE;
				_vala_code_node_unref0 (array_type);
				return result;
			}
			_tmp498_ = vala_binary_expression_get_right (self);
			_tmp499_ = _tmp498_;
			_tmp500_ = array_type;
			_tmp501_ = vala_array_type_get_element_type (_tmp500_);
			_tmp502_ = _tmp501_;
			_tmp503_ = vala_data_type_copy (_tmp502_);
			_tmp504_ = _tmp503_;
			vala_expression_set_target_type (_tmp499_, _tmp504_);
			_vala_code_node_unref0 (_tmp504_);
			_tmp505_ = array_type;
			_tmp506_ = vala_data_type_copy ((ValaDataType*) _tmp505_);
			_tmp507_ = _tmp506_;
			vala_expression_set_value_type ((ValaExpression*) self, _tmp507_);
			_vala_code_node_unref0 (_tmp507_);
			_tmp508_ = vala_expression_get_value_type ((ValaExpression*) self);
			_tmp509_ = _tmp508_;
			vala_data_type_set_value_owned (_tmp509_, TRUE);
			_vala_code_node_unref0 (array_type);
		} else {
			gboolean _tmp510_ = FALSE;
			gboolean _tmp511_ = FALSE;
			gboolean _tmp512_ = FALSE;
			ValaBinaryOperator _tmp513_;
			_tmp513_ = self->priv->_operator;
			if (_tmp513_ == VALA_BINARY_OPERATOR_PLUS) {
				_tmp512_ = TRUE;
			} else {
				ValaBinaryOperator _tmp514_;
				_tmp514_ = self->priv->_operator;
				_tmp512_ = _tmp514_ == VALA_BINARY_OPERATOR_MINUS;
			}
			if (_tmp512_) {
				_tmp511_ = TRUE;
			} else {
				ValaBinaryOperator _tmp515_;
				_tmp515_ = self->priv->_operator;
				_tmp511_ = _tmp515_ == VALA_BINARY_OPERATOR_MUL;
			}
			if (_tmp511_) {
				_tmp510_ = TRUE;
			} else {
				ValaBinaryOperator _tmp516_;
				_tmp516_ = self->priv->_operator;
				_tmp510_ = _tmp516_ == VALA_BINARY_OPERATOR_DIV;
			}
			if (_tmp510_) {
				ValaExpression* _tmp517_;
				ValaExpression* _tmp518_;
				ValaDataType* _tmp519_;
				ValaDataType* _tmp520_;
				ValaDataType* _tmp567_;
				ValaDataType* _tmp568_;
				ValaDataType* _tmp582_;
				ValaDataType* _tmp583_;
				_tmp517_ = vala_binary_expression_get_left (self);
				_tmp518_ = _tmp517_;
				_tmp519_ = vala_expression_get_value_type (_tmp518_);
				_tmp520_ = _tmp519_;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp520_, VALA_TYPE_POINTER_TYPE)) {
					ValaPointerType* pointer_type = NULL;
					ValaExpression* _tmp521_;
					ValaExpression* _tmp522_;
					ValaDataType* _tmp523_;
					ValaDataType* _tmp524_;
					ValaPointerType* _tmp525_;
					ValaPointerType* _tmp526_;
					ValaDataType* _tmp527_;
					ValaDataType* _tmp528_;
					ValaStruct* offset_type = NULL;
					ValaExpression* _tmp531_;
					ValaExpression* _tmp532_;
					ValaDataType* _tmp533_;
					ValaDataType* _tmp534_;
					ValaTypeSymbol* _tmp535_;
					ValaTypeSymbol* _tmp536_;
					ValaStruct* _tmp537_;
					gboolean _tmp538_ = FALSE;
					ValaStruct* _tmp539_;
					_tmp521_ = vala_binary_expression_get_left (self);
					_tmp522_ = _tmp521_;
					_tmp523_ = vala_expression_get_value_type (_tmp522_);
					_tmp524_ = _tmp523_;
					_tmp525_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp524_, VALA_TYPE_POINTER_TYPE, ValaPointerType));
					pointer_type = _tmp525_;
					_tmp526_ = pointer_type;
					_tmp527_ = vala_pointer_type_get_base_type (_tmp526_);
					_tmp528_ = _tmp527_;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp528_, VALA_TYPE_VOID_TYPE)) {
						ValaSourceReference* _tmp529_;
						ValaSourceReference* _tmp530_;
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
						_tmp529_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp530_ = _tmp529_;
						vala_report_error (_tmp530_, "Pointer arithmetic not supported for `void*'");
						result = FALSE;
						_vala_code_node_unref0 (pointer_type);
						return result;
					}
					_tmp531_ = vala_binary_expression_get_right (self);
					_tmp532_ = _tmp531_;
					_tmp533_ = vala_expression_get_value_type (_tmp532_);
					_tmp534_ = _tmp533_;
					_tmp535_ = vala_data_type_get_data_type (_tmp534_);
					_tmp536_ = _tmp535_;
					_tmp537_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp536_, VALA_TYPE_STRUCT) ? ((ValaStruct*) _tmp536_) : NULL);
					offset_type = _tmp537_;
					_tmp539_ = offset_type;
					if (_tmp539_ != NULL) {
						ValaStruct* _tmp540_;
						gboolean _tmp541_;
						_tmp540_ = offset_type;
						_tmp541_ = vala_struct_is_integer_type (_tmp540_);
						_tmp538_ = _tmp541_;
					} else {
						_tmp538_ = FALSE;
					}
					if (_tmp538_) {
						gboolean _tmp542_ = FALSE;
						ValaBinaryOperator _tmp543_;
						_tmp543_ = self->priv->_operator;
						if (_tmp543_ == VALA_BINARY_OPERATOR_PLUS) {
							_tmp542_ = TRUE;
						} else {
							ValaBinaryOperator _tmp544_;
							_tmp544_ = self->priv->_operator;
							_tmp542_ = _tmp544_ == VALA_BINARY_OPERATOR_MINUS;
						}
						if (_tmp542_) {
							ValaExpression* _tmp545_;
							ValaExpression* _tmp546_;
							ValaDataType* _tmp547_;
							ValaDataType* _tmp548_;
							ValaDataType* _tmp549_;
							ValaDataType* _tmp550_;
							_tmp545_ = vala_binary_expression_get_left (self);
							_tmp546_ = _tmp545_;
							_tmp547_ = vala_expression_get_value_type (_tmp546_);
							_tmp548_ = _tmp547_;
							_tmp549_ = vala_data_type_copy (_tmp548_);
							_tmp550_ = _tmp549_;
							vala_expression_set_value_type ((ValaExpression*) self, _tmp550_);
							_vala_code_node_unref0 (_tmp550_);
						}
					} else {
						ValaExpression* _tmp551_;
						ValaExpression* _tmp552_;
						ValaDataType* _tmp553_;
						ValaDataType* _tmp554_;
						_tmp551_ = vala_binary_expression_get_right (self);
						_tmp552_ = _tmp551_;
						_tmp553_ = vala_expression_get_value_type (_tmp552_);
						_tmp554_ = _tmp553_;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp554_, VALA_TYPE_POINTER_TYPE)) {
							ValaCodeContext* _tmp555_;
							ValaSemanticAnalyzer* _tmp556_;
							ValaSemanticAnalyzer* _tmp557_;
							ValaDataType* _tmp558_;
							_tmp555_ = context;
							_tmp556_ = vala_code_context_get_analyzer (_tmp555_);
							_tmp557_ = _tmp556_;
							_tmp558_ = _tmp557_->size_t_type;
							vala_expression_set_value_type ((ValaExpression*) self, _tmp558_);
						}
					}
					_vala_code_node_unref0 (offset_type);
					_vala_code_node_unref0 (pointer_type);
				} else {
					ValaExpression* _tmp559_;
					ValaExpression* _tmp560_;
					ValaDataType* _tmp561_;
					ValaDataType* _tmp562_;
					ValaExpression* _tmp563_;
					ValaExpression* _tmp564_;
					ValaDataType* _tmp565_;
					ValaDataType* _tmp566_;
					_tmp559_ = vala_binary_expression_get_left (self);
					_tmp560_ = _tmp559_;
					_tmp561_ = vala_expression_get_target_type (_tmp560_);
					_tmp562_ = _tmp561_;
					vala_data_type_set_nullable (_tmp562_, FALSE);
					_tmp563_ = vala_binary_expression_get_right (self);
					_tmp564_ = _tmp563_;
					_tmp565_ = vala_expression_get_target_type (_tmp564_);
					_tmp566_ = _tmp565_;
					vala_data_type_set_nullable (_tmp566_, FALSE);
				}
				_tmp567_ = vala_expression_get_value_type ((ValaExpression*) self);
				_tmp568_ = _tmp567_;
				if (_tmp568_ == NULL) {
					ValaCodeContext* _tmp569_;
					ValaSemanticAnalyzer* _tmp570_;
					ValaSemanticAnalyzer* _tmp571_;
					ValaExpression* _tmp572_;
					ValaExpression* _tmp573_;
					ValaDataType* _tmp574_;
					ValaDataType* _tmp575_;
					ValaExpression* _tmp576_;
					ValaExpression* _tmp577_;
					ValaDataType* _tmp578_;
					ValaDataType* _tmp579_;
					ValaDataType* _tmp580_;
					ValaDataType* _tmp581_;
					_tmp569_ = context;
					_tmp570_ = vala_code_context_get_analyzer (_tmp569_);
					_tmp571_ = _tmp570_;
					_tmp572_ = vala_binary_expression_get_left (self);
					_tmp573_ = _tmp572_;
					_tmp574_ = vala_expression_get_target_type (_tmp573_);
					_tmp575_ = _tmp574_;
					_tmp576_ = vala_binary_expression_get_right (self);
					_tmp577_ = _tmp576_;
					_tmp578_ = vala_expression_get_target_type (_tmp577_);
					_tmp579_ = _tmp578_;
					_tmp580_ = vala_semantic_analyzer_get_arithmetic_result_type (_tmp571_, _tmp575_, _tmp579_);
					_tmp581_ = _tmp580_;
					vala_expression_set_value_type ((ValaExpression*) self, _tmp581_);
					_vala_code_node_unref0 (_tmp581_);
				}
				_tmp582_ = vala_expression_get_value_type ((ValaExpression*) self);
				_tmp583_ = _tmp582_;
				if (_tmp583_ == NULL) {
					ValaSourceReference* _tmp584_;
					ValaSourceReference* _tmp585_;
					ValaExpression* _tmp586_;
					ValaExpression* _tmp587_;
					ValaDataType* _tmp588_;
					ValaDataType* _tmp589_;
					gchar* _tmp590_;
					gchar* _tmp591_;
					ValaExpression* _tmp592_;
					ValaExpression* _tmp593_;
					ValaDataType* _tmp594_;
					ValaDataType* _tmp595_;
					gchar* _tmp596_;
					gchar* _tmp597_;
					gchar* _tmp598_;
					gchar* _tmp599_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp584_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp585_ = _tmp584_;
					_tmp586_ = vala_binary_expression_get_left (self);
					_tmp587_ = _tmp586_;
					_tmp588_ = vala_expression_get_value_type (_tmp587_);
					_tmp589_ = _tmp588_;
					_tmp590_ = vala_code_node_to_string ((ValaCodeNode*) _tmp589_);
					_tmp591_ = _tmp590_;
					_tmp592_ = vala_binary_expression_get_right (self);
					_tmp593_ = _tmp592_;
					_tmp594_ = vala_expression_get_value_type (_tmp593_);
					_tmp595_ = _tmp594_;
					_tmp596_ = vala_code_node_to_string ((ValaCodeNode*) _tmp595_);
					_tmp597_ = _tmp596_;
					_tmp598_ = g_strdup_printf ("Arithmetic operation not supported for types `%s' and `%s'", _tmp591_, _tmp597_);
					_tmp599_ = _tmp598_;
					vala_report_error (_tmp585_, _tmp599_);
					_g_free0 (_tmp599_);
					_g_free0 (_tmp597_);
					_g_free0 (_tmp591_);
					result = FALSE;
					return result;
				}
			} else {
				gboolean _tmp600_ = FALSE;
				gboolean _tmp601_ = FALSE;
				ValaBinaryOperator _tmp602_;
				_tmp602_ = self->priv->_operator;
				if (_tmp602_ == VALA_BINARY_OPERATOR_MOD) {
					_tmp601_ = TRUE;
				} else {
					ValaBinaryOperator _tmp603_;
					_tmp603_ = self->priv->_operator;
					_tmp601_ = _tmp603_ == VALA_BINARY_OPERATOR_SHIFT_LEFT;
				}
				if (_tmp601_) {
					_tmp600_ = TRUE;
				} else {
					ValaBinaryOperator _tmp604_;
					_tmp604_ = self->priv->_operator;
					_tmp600_ = _tmp604_ == VALA_BINARY_OPERATOR_SHIFT_RIGHT;
				}
				if (_tmp600_) {
					ValaExpression* _tmp605_;
					ValaExpression* _tmp606_;
					ValaDataType* _tmp607_;
					ValaDataType* _tmp608_;
					ValaExpression* _tmp609_;
					ValaExpression* _tmp610_;
					ValaDataType* _tmp611_;
					ValaDataType* _tmp612_;
					ValaCodeContext* _tmp613_;
					ValaSemanticAnalyzer* _tmp614_;
					ValaSemanticAnalyzer* _tmp615_;
					ValaExpression* _tmp616_;
					ValaExpression* _tmp617_;
					ValaDataType* _tmp618_;
					ValaDataType* _tmp619_;
					ValaExpression* _tmp620_;
					ValaExpression* _tmp621_;
					ValaDataType* _tmp622_;
					ValaDataType* _tmp623_;
					ValaDataType* _tmp624_;
					ValaDataType* _tmp625_;
					ValaDataType* _tmp626_;
					ValaDataType* _tmp627_;
					_tmp605_ = vala_binary_expression_get_left (self);
					_tmp606_ = _tmp605_;
					_tmp607_ = vala_expression_get_target_type (_tmp606_);
					_tmp608_ = _tmp607_;
					vala_data_type_set_nullable (_tmp608_, FALSE);
					_tmp609_ = vala_binary_expression_get_right (self);
					_tmp610_ = _tmp609_;
					_tmp611_ = vala_expression_get_target_type (_tmp610_);
					_tmp612_ = _tmp611_;
					vala_data_type_set_nullable (_tmp612_, FALSE);
					_tmp613_ = context;
					_tmp614_ = vala_code_context_get_analyzer (_tmp613_);
					_tmp615_ = _tmp614_;
					_tmp616_ = vala_binary_expression_get_left (self);
					_tmp617_ = _tmp616_;
					_tmp618_ = vala_expression_get_target_type (_tmp617_);
					_tmp619_ = _tmp618_;
					_tmp620_ = vala_binary_expression_get_right (self);
					_tmp621_ = _tmp620_;
					_tmp622_ = vala_expression_get_target_type (_tmp621_);
					_tmp623_ = _tmp622_;
					_tmp624_ = vala_semantic_analyzer_get_arithmetic_result_type (_tmp615_, _tmp619_, _tmp623_);
					_tmp625_ = _tmp624_;
					vala_expression_set_value_type ((ValaExpression*) self, _tmp625_);
					_vala_code_node_unref0 (_tmp625_);
					_tmp626_ = vala_expression_get_value_type ((ValaExpression*) self);
					_tmp627_ = _tmp626_;
					if (_tmp627_ == NULL) {
						ValaSourceReference* _tmp628_;
						ValaSourceReference* _tmp629_;
						ValaExpression* _tmp630_;
						ValaExpression* _tmp631_;
						ValaDataType* _tmp632_;
						ValaDataType* _tmp633_;
						gchar* _tmp634_;
						gchar* _tmp635_;
						ValaExpression* _tmp636_;
						ValaExpression* _tmp637_;
						ValaDataType* _tmp638_;
						ValaDataType* _tmp639_;
						gchar* _tmp640_;
						gchar* _tmp641_;
						gchar* _tmp642_;
						gchar* _tmp643_;
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
						_tmp628_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp629_ = _tmp628_;
						_tmp630_ = vala_binary_expression_get_left (self);
						_tmp631_ = _tmp630_;
						_tmp632_ = vala_expression_get_value_type (_tmp631_);
						_tmp633_ = _tmp632_;
						_tmp634_ = vala_code_node_to_string ((ValaCodeNode*) _tmp633_);
						_tmp635_ = _tmp634_;
						_tmp636_ = vala_binary_expression_get_right (self);
						_tmp637_ = _tmp636_;
						_tmp638_ = vala_expression_get_value_type (_tmp637_);
						_tmp639_ = _tmp638_;
						_tmp640_ = vala_code_node_to_string ((ValaCodeNode*) _tmp639_);
						_tmp641_ = _tmp640_;
						_tmp642_ = g_strdup_printf ("Arithmetic operation not supported for types `%s' and `%s'", _tmp635_, _tmp641_);
						_tmp643_ = _tmp642_;
						vala_report_error (_tmp629_, _tmp643_);
						_g_free0 (_tmp643_);
						_g_free0 (_tmp641_);
						_g_free0 (_tmp635_);
						result = FALSE;
						return result;
					}
				} else {
					gboolean _tmp644_ = FALSE;
					gboolean _tmp645_ = FALSE;
					gboolean _tmp646_ = FALSE;
					ValaBinaryOperator _tmp647_;
					_tmp647_ = self->priv->_operator;
					if (_tmp647_ == VALA_BINARY_OPERATOR_LESS_THAN) {
						_tmp646_ = TRUE;
					} else {
						ValaBinaryOperator _tmp648_;
						_tmp648_ = self->priv->_operator;
						_tmp646_ = _tmp648_ == VALA_BINARY_OPERATOR_GREATER_THAN;
					}
					if (_tmp646_) {
						_tmp645_ = TRUE;
					} else {
						ValaBinaryOperator _tmp649_;
						_tmp649_ = self->priv->_operator;
						_tmp645_ = _tmp649_ == VALA_BINARY_OPERATOR_LESS_THAN_OR_EQUAL;
					}
					if (_tmp645_) {
						_tmp644_ = TRUE;
					} else {
						ValaBinaryOperator _tmp650_;
						_tmp650_ = self->priv->_operator;
						_tmp644_ = _tmp650_ == VALA_BINARY_OPERATOR_GREATER_THAN_OR_EQUAL;
					}
					if (_tmp644_) {
						gboolean _tmp651_ = FALSE;
						ValaExpression* _tmp652_;
						ValaExpression* _tmp653_;
						ValaDataType* _tmp654_;
						ValaDataType* _tmp655_;
						ValaCodeContext* _tmp656_;
						ValaSemanticAnalyzer* _tmp657_;
						ValaSemanticAnalyzer* _tmp658_;
						ValaDataType* _tmp659_;
						gboolean _tmp660_;
						ValaCodeContext* _tmp744_;
						ValaSemanticAnalyzer* _tmp745_;
						ValaSemanticAnalyzer* _tmp746_;
						ValaDataType* _tmp747_;
						_tmp652_ = vala_binary_expression_get_left (self);
						_tmp653_ = _tmp652_;
						_tmp654_ = vala_expression_get_value_type (_tmp653_);
						_tmp655_ = _tmp654_;
						_tmp656_ = context;
						_tmp657_ = vala_code_context_get_analyzer (_tmp656_);
						_tmp658_ = _tmp657_;
						_tmp659_ = _tmp658_->string_type;
						_tmp660_ = vala_data_type_compatible (_tmp655_, _tmp659_);
						if (_tmp660_) {
							ValaExpression* _tmp661_;
							ValaExpression* _tmp662_;
							ValaDataType* _tmp663_;
							ValaDataType* _tmp664_;
							ValaCodeContext* _tmp665_;
							ValaSemanticAnalyzer* _tmp666_;
							ValaSemanticAnalyzer* _tmp667_;
							ValaDataType* _tmp668_;
							gboolean _tmp669_;
							_tmp661_ = vala_binary_expression_get_right (self);
							_tmp662_ = _tmp661_;
							_tmp663_ = vala_expression_get_value_type (_tmp662_);
							_tmp664_ = _tmp663_;
							_tmp665_ = context;
							_tmp666_ = vala_code_context_get_analyzer (_tmp665_);
							_tmp667_ = _tmp666_;
							_tmp668_ = _tmp667_->string_type;
							_tmp669_ = vala_data_type_compatible (_tmp664_, _tmp668_);
							_tmp651_ = _tmp669_;
						} else {
							_tmp651_ = FALSE;
						}
						if (_tmp651_) {
						} else {
							gboolean _tmp670_ = FALSE;
							ValaExpression* _tmp671_;
							ValaExpression* _tmp672_;
							ValaDataType* _tmp673_;
							ValaDataType* _tmp674_;
							_tmp671_ = vala_binary_expression_get_left (self);
							_tmp672_ = _tmp671_;
							_tmp673_ = vala_expression_get_value_type (_tmp672_);
							_tmp674_ = _tmp673_;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp674_, VALA_TYPE_POINTER_TYPE)) {
								ValaExpression* _tmp675_;
								ValaExpression* _tmp676_;
								ValaDataType* _tmp677_;
								ValaDataType* _tmp678_;
								_tmp675_ = vala_binary_expression_get_right (self);
								_tmp676_ = _tmp675_;
								_tmp677_ = vala_expression_get_value_type (_tmp676_);
								_tmp678_ = _tmp677_;
								_tmp670_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp678_, VALA_TYPE_POINTER_TYPE);
							} else {
								_tmp670_ = FALSE;
							}
							if (_tmp670_) {
							} else {
								ValaDataType* resulting_type = NULL;
								gboolean _tmp679_;
								ValaDataType* _tmp708_;
								gboolean _tmp725_;
								ValaExpression* _tmp731_;
								ValaExpression* _tmp732_;
								ValaDataType* _tmp733_;
								ValaDataType* _tmp734_;
								ValaDataType* _tmp735_;
								ValaExpression* _tmp736_;
								ValaExpression* _tmp737_;
								ValaDataType* _tmp738_;
								ValaDataType* _tmp739_;
								ValaExpression* _tmp740_;
								ValaExpression* _tmp741_;
								ValaDataType* _tmp742_;
								ValaDataType* _tmp743_;
								_tmp679_ = self->chained;
								if (_tmp679_) {
									ValaBinaryExpression* lbe = NULL;
									ValaExpression* _tmp680_;
									ValaExpression* _tmp681_;
									ValaBinaryExpression* _tmp682_;
									ValaCodeContext* _tmp683_;
									ValaSemanticAnalyzer* _tmp684_;
									ValaSemanticAnalyzer* _tmp685_;
									ValaBinaryExpression* _tmp686_;
									ValaExpression* _tmp687_;
									ValaExpression* _tmp688_;
									ValaDataType* _tmp689_;
									ValaDataType* _tmp690_;
									ValaExpression* _tmp691_;
									ValaExpression* _tmp692_;
									ValaDataType* _tmp693_;
									ValaDataType* _tmp694_;
									ValaDataType* _tmp695_;
									_tmp680_ = vala_binary_expression_get_left (self);
									_tmp681_ = _tmp680_;
									_tmp682_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp681_, VALA_TYPE_BINARY_EXPRESSION, ValaBinaryExpression));
									lbe = _tmp682_;
									_tmp683_ = context;
									_tmp684_ = vala_code_context_get_analyzer (_tmp683_);
									_tmp685_ = _tmp684_;
									_tmp686_ = lbe;
									_tmp687_ = vala_binary_expression_get_right (_tmp686_);
									_tmp688_ = _tmp687_;
									_tmp689_ = vala_expression_get_target_type (_tmp688_);
									_tmp690_ = _tmp689_;
									_tmp691_ = vala_binary_expression_get_right (self);
									_tmp692_ = _tmp691_;
									_tmp693_ = vala_expression_get_target_type (_tmp692_);
									_tmp694_ = _tmp693_;
									_tmp695_ = vala_semantic_analyzer_get_arithmetic_result_type (_tmp685_, _tmp690_, _tmp694_);
									_vala_code_node_unref0 (resulting_type);
									resulting_type = _tmp695_;
									_vala_code_node_unref0 (lbe);
								} else {
									ValaCodeContext* _tmp696_;
									ValaSemanticAnalyzer* _tmp697_;
									ValaSemanticAnalyzer* _tmp698_;
									ValaExpression* _tmp699_;
									ValaExpression* _tmp700_;
									ValaDataType* _tmp701_;
									ValaDataType* _tmp702_;
									ValaExpression* _tmp703_;
									ValaExpression* _tmp704_;
									ValaDataType* _tmp705_;
									ValaDataType* _tmp706_;
									ValaDataType* _tmp707_;
									_tmp696_ = context;
									_tmp697_ = vala_code_context_get_analyzer (_tmp696_);
									_tmp698_ = _tmp697_;
									_tmp699_ = vala_binary_expression_get_left (self);
									_tmp700_ = _tmp699_;
									_tmp701_ = vala_expression_get_target_type (_tmp700_);
									_tmp702_ = _tmp701_;
									_tmp703_ = vala_binary_expression_get_right (self);
									_tmp704_ = _tmp703_;
									_tmp705_ = vala_expression_get_target_type (_tmp704_);
									_tmp706_ = _tmp705_;
									_tmp707_ = vala_semantic_analyzer_get_arithmetic_result_type (_tmp698_, _tmp702_, _tmp706_);
									_vala_code_node_unref0 (resulting_type);
									resulting_type = _tmp707_;
								}
								_tmp708_ = resulting_type;
								if (_tmp708_ == NULL) {
									ValaSourceReference* _tmp709_;
									ValaSourceReference* _tmp710_;
									ValaExpression* _tmp711_;
									ValaExpression* _tmp712_;
									ValaDataType* _tmp713_;
									ValaDataType* _tmp714_;
									gchar* _tmp715_;
									gchar* _tmp716_;
									ValaExpression* _tmp717_;
									ValaExpression* _tmp718_;
									ValaDataType* _tmp719_;
									ValaDataType* _tmp720_;
									gchar* _tmp721_;
									gchar* _tmp722_;
									gchar* _tmp723_;
									gchar* _tmp724_;
									vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
									_tmp709_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
									_tmp710_ = _tmp709_;
									_tmp711_ = vala_binary_expression_get_left (self);
									_tmp712_ = _tmp711_;
									_tmp713_ = vala_expression_get_value_type (_tmp712_);
									_tmp714_ = _tmp713_;
									_tmp715_ = vala_code_node_to_string ((ValaCodeNode*) _tmp714_);
									_tmp716_ = _tmp715_;
									_tmp717_ = vala_binary_expression_get_right (self);
									_tmp718_ = _tmp717_;
									_tmp719_ = vala_expression_get_value_type (_tmp718_);
									_tmp720_ = _tmp719_;
									_tmp721_ = vala_code_node_to_string ((ValaCodeNode*) _tmp720_);
									_tmp722_ = _tmp721_;
									_tmp723_ = g_strdup_printf ("Relational operation not supported for types `%s' and `%s'", _tmp716_, _tmp722_);
									_tmp724_ = _tmp723_;
									vala_report_error (_tmp710_, _tmp724_);
									_g_free0 (_tmp724_);
									_g_free0 (_tmp722_);
									_g_free0 (_tmp716_);
									result = FALSE;
									_vala_code_node_unref0 (resulting_type);
									return result;
								}
								_tmp725_ = self->chained;
								if (!_tmp725_) {
									ValaExpression* _tmp726_;
									ValaExpression* _tmp727_;
									ValaDataType* _tmp728_;
									ValaDataType* _tmp729_;
									ValaDataType* _tmp730_;
									_tmp726_ = vala_binary_expression_get_left (self);
									_tmp727_ = _tmp726_;
									_tmp728_ = resulting_type;
									_tmp729_ = vala_data_type_copy (_tmp728_);
									_tmp730_ = _tmp729_;
									vala_expression_set_target_type (_tmp727_, _tmp730_);
									_vala_code_node_unref0 (_tmp730_);
								}
								_tmp731_ = vala_binary_expression_get_right (self);
								_tmp732_ = _tmp731_;
								_tmp733_ = resulting_type;
								_tmp734_ = vala_data_type_copy (_tmp733_);
								_tmp735_ = _tmp734_;
								vala_expression_set_target_type (_tmp732_, _tmp735_);
								_vala_code_node_unref0 (_tmp735_);
								_tmp736_ = vala_binary_expression_get_left (self);
								_tmp737_ = _tmp736_;
								_tmp738_ = vala_expression_get_target_type (_tmp737_);
								_tmp739_ = _tmp738_;
								vala_data_type_set_nullable (_tmp739_, FALSE);
								_tmp740_ = vala_binary_expression_get_right (self);
								_tmp741_ = _tmp740_;
								_tmp742_ = vala_expression_get_target_type (_tmp741_);
								_tmp743_ = _tmp742_;
								vala_data_type_set_nullable (_tmp743_, FALSE);
								_vala_code_node_unref0 (resulting_type);
							}
						}
						_tmp744_ = context;
						_tmp745_ = vala_code_context_get_analyzer (_tmp744_);
						_tmp746_ = _tmp745_;
						_tmp747_ = _tmp746_->bool_type;
						vala_expression_set_value_type ((ValaExpression*) self, _tmp747_);
					} else {
						gboolean _tmp748_ = FALSE;
						ValaBinaryOperator _tmp749_;
						_tmp749_ = self->priv->_operator;
						if (_tmp749_ == VALA_BINARY_OPERATOR_EQUALITY) {
							_tmp748_ = TRUE;
						} else {
							ValaBinaryOperator _tmp750_;
							_tmp750_ = self->priv->_operator;
							_tmp748_ = _tmp750_ == VALA_BINARY_OPERATOR_INEQUALITY;
						}
						if (_tmp748_) {
							gboolean _tmp751_ = FALSE;
							ValaExpression* _tmp752_;
							ValaExpression* _tmp753_;
							ValaDataType* _tmp754_;
							ValaDataType* _tmp755_;
							ValaExpression* _tmp756_;
							ValaExpression* _tmp757_;
							ValaDataType* _tmp758_;
							ValaDataType* _tmp759_;
							gboolean _tmp760_;
							ValaDataType* resulting_type = NULL;
							ValaCodeContext* _tmp786_;
							ValaSemanticAnalyzer* _tmp787_;
							ValaSemanticAnalyzer* _tmp788_;
							ValaExpression* _tmp789_;
							ValaExpression* _tmp790_;
							ValaDataType* _tmp791_;
							ValaDataType* _tmp792_;
							ValaExpression* _tmp793_;
							ValaExpression* _tmp794_;
							ValaDataType* _tmp795_;
							ValaDataType* _tmp796_;
							ValaDataType* _tmp797_;
							ValaDataType* _tmp798_;
							ValaExpression* _tmp809_;
							ValaExpression* _tmp810_;
							ValaDataType* _tmp811_;
							ValaDataType* _tmp812_;
							ValaExpression* _tmp813_;
							ValaExpression* _tmp814_;
							ValaDataType* _tmp815_;
							ValaDataType* _tmp816_;
							ValaExpression* _tmp817_;
							ValaExpression* _tmp818_;
							ValaDataType* _tmp819_;
							ValaDataType* _tmp820_;
							gboolean _tmp821_;
							gboolean _tmp822_;
							ValaExpression* _tmp823_;
							ValaExpression* _tmp824_;
							ValaDataType* _tmp825_;
							ValaDataType* _tmp826_;
							gboolean _tmp827_;
							gboolean _tmp828_;
							ValaCodeContext* _tmp837_;
							ValaSemanticAnalyzer* _tmp838_;
							ValaSemanticAnalyzer* _tmp839_;
							ValaDataType* _tmp840_;
							_tmp752_ = vala_binary_expression_get_right (self);
							_tmp753_ = _tmp752_;
							_tmp754_ = vala_expression_get_value_type (_tmp753_);
							_tmp755_ = _tmp754_;
							_tmp756_ = vala_binary_expression_get_left (self);
							_tmp757_ = _tmp756_;
							_tmp758_ = vala_expression_get_value_type (_tmp757_);
							_tmp759_ = _tmp758_;
							_tmp760_ = vala_data_type_compatible (_tmp755_, _tmp759_);
							if (!_tmp760_) {
								ValaExpression* _tmp761_;
								ValaExpression* _tmp762_;
								ValaDataType* _tmp763_;
								ValaDataType* _tmp764_;
								ValaExpression* _tmp765_;
								ValaExpression* _tmp766_;
								ValaDataType* _tmp767_;
								ValaDataType* _tmp768_;
								gboolean _tmp769_;
								_tmp761_ = vala_binary_expression_get_left (self);
								_tmp762_ = _tmp761_;
								_tmp763_ = vala_expression_get_value_type (_tmp762_);
								_tmp764_ = _tmp763_;
								_tmp765_ = vala_binary_expression_get_right (self);
								_tmp766_ = _tmp765_;
								_tmp767_ = vala_expression_get_value_type (_tmp766_);
								_tmp768_ = _tmp767_;
								_tmp769_ = vala_data_type_compatible (_tmp764_, _tmp768_);
								_tmp751_ = !_tmp769_;
							} else {
								_tmp751_ = FALSE;
							}
							if (_tmp751_) {
								ValaSourceReference* _tmp770_;
								ValaSourceReference* _tmp771_;
								ValaExpression* _tmp772_;
								ValaExpression* _tmp773_;
								ValaDataType* _tmp774_;
								ValaDataType* _tmp775_;
								gchar* _tmp776_;
								gchar* _tmp777_;
								ValaExpression* _tmp778_;
								ValaExpression* _tmp779_;
								ValaDataType* _tmp780_;
								ValaDataType* _tmp781_;
								gchar* _tmp782_;
								gchar* _tmp783_;
								gchar* _tmp784_;
								gchar* _tmp785_;
								_tmp770_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
								_tmp771_ = _tmp770_;
								_tmp772_ = vala_binary_expression_get_right (self);
								_tmp773_ = _tmp772_;
								_tmp774_ = vala_expression_get_value_type (_tmp773_);
								_tmp775_ = _tmp774_;
								_tmp776_ = vala_code_node_to_string ((ValaCodeNode*) _tmp775_);
								_tmp777_ = _tmp776_;
								_tmp778_ = vala_binary_expression_get_left (self);
								_tmp779_ = _tmp778_;
								_tmp780_ = vala_expression_get_value_type (_tmp779_);
								_tmp781_ = _tmp780_;
								_tmp782_ = vala_code_node_to_string ((ValaCodeNode*) _tmp781_);
								_tmp783_ = _tmp782_;
								_tmp784_ = g_strdup_printf ("Equality operation: `%s' and `%s' are incompatible", _tmp777_, _tmp783_);
								_tmp785_ = _tmp784_;
								vala_report_error (_tmp771_, _tmp785_);
								_g_free0 (_tmp785_);
								_g_free0 (_tmp783_);
								_g_free0 (_tmp777_);
								vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
								result = FALSE;
								return result;
							}
							_tmp786_ = context;
							_tmp787_ = vala_code_context_get_analyzer (_tmp786_);
							_tmp788_ = _tmp787_;
							_tmp789_ = vala_binary_expression_get_left (self);
							_tmp790_ = _tmp789_;
							_tmp791_ = vala_expression_get_target_type (_tmp790_);
							_tmp792_ = _tmp791_;
							_tmp793_ = vala_binary_expression_get_right (self);
							_tmp794_ = _tmp793_;
							_tmp795_ = vala_expression_get_target_type (_tmp794_);
							_tmp796_ = _tmp795_;
							_tmp797_ = vala_semantic_analyzer_get_arithmetic_result_type (_tmp788_, _tmp792_, _tmp796_);
							resulting_type = _tmp797_;
							_tmp798_ = resulting_type;
							if (_tmp798_ != NULL) {
								ValaExpression* _tmp799_;
								ValaExpression* _tmp800_;
								ValaDataType* _tmp801_;
								ValaDataType* _tmp802_;
								ValaDataType* _tmp803_;
								ValaExpression* _tmp804_;
								ValaExpression* _tmp805_;
								ValaDataType* _tmp806_;
								ValaDataType* _tmp807_;
								ValaDataType* _tmp808_;
								_tmp799_ = vala_binary_expression_get_left (self);
								_tmp800_ = _tmp799_;
								_tmp801_ = resulting_type;
								_tmp802_ = vala_data_type_copy (_tmp801_);
								_tmp803_ = _tmp802_;
								vala_expression_set_target_type (_tmp800_, _tmp803_);
								_vala_code_node_unref0 (_tmp803_);
								_tmp804_ = vala_binary_expression_get_right (self);
								_tmp805_ = _tmp804_;
								_tmp806_ = resulting_type;
								_tmp807_ = vala_data_type_copy (_tmp806_);
								_tmp808_ = _tmp807_;
								vala_expression_set_target_type (_tmp805_, _tmp808_);
								_vala_code_node_unref0 (_tmp808_);
							}
							_tmp809_ = vala_binary_expression_get_left (self);
							_tmp810_ = _tmp809_;
							_tmp811_ = vala_expression_get_target_type (_tmp810_);
							_tmp812_ = _tmp811_;
							vala_data_type_set_value_owned (_tmp812_, FALSE);
							_tmp813_ = vala_binary_expression_get_right (self);
							_tmp814_ = _tmp813_;
							_tmp815_ = vala_expression_get_target_type (_tmp814_);
							_tmp816_ = _tmp815_;
							vala_data_type_set_value_owned (_tmp816_, FALSE);
							_tmp817_ = vala_binary_expression_get_left (self);
							_tmp818_ = _tmp817_;
							_tmp819_ = vala_expression_get_value_type (_tmp818_);
							_tmp820_ = _tmp819_;
							_tmp821_ = vala_data_type_get_nullable (_tmp820_);
							_tmp822_ = _tmp821_;
							_tmp823_ = vala_binary_expression_get_right (self);
							_tmp824_ = _tmp823_;
							_tmp825_ = vala_expression_get_value_type (_tmp824_);
							_tmp826_ = _tmp825_;
							_tmp827_ = vala_data_type_get_nullable (_tmp826_);
							_tmp828_ = _tmp827_;
							if (_tmp822_ != _tmp828_) {
								ValaExpression* _tmp829_;
								ValaExpression* _tmp830_;
								ValaDataType* _tmp831_;
								ValaDataType* _tmp832_;
								ValaExpression* _tmp833_;
								ValaExpression* _tmp834_;
								ValaDataType* _tmp835_;
								ValaDataType* _tmp836_;
								_tmp829_ = vala_binary_expression_get_left (self);
								_tmp830_ = _tmp829_;
								_tmp831_ = vala_expression_get_target_type (_tmp830_);
								_tmp832_ = _tmp831_;
								vala_data_type_set_nullable (_tmp832_, TRUE);
								_tmp833_ = vala_binary_expression_get_right (self);
								_tmp834_ = _tmp833_;
								_tmp835_ = vala_expression_get_target_type (_tmp834_);
								_tmp836_ = _tmp835_;
								vala_data_type_set_nullable (_tmp836_, TRUE);
							}
							_tmp837_ = context;
							_tmp838_ = vala_code_context_get_analyzer (_tmp837_);
							_tmp839_ = _tmp838_;
							_tmp840_ = _tmp839_->bool_type;
							vala_expression_set_value_type ((ValaExpression*) self, _tmp840_);
							_vala_code_node_unref0 (resulting_type);
						} else {
							gboolean _tmp841_ = FALSE;
							gboolean _tmp842_ = FALSE;
							ValaBinaryOperator _tmp843_;
							_tmp843_ = self->priv->_operator;
							if (_tmp843_ == VALA_BINARY_OPERATOR_BITWISE_AND) {
								_tmp842_ = TRUE;
							} else {
								ValaBinaryOperator _tmp844_;
								_tmp844_ = self->priv->_operator;
								_tmp842_ = _tmp844_ == VALA_BINARY_OPERATOR_BITWISE_OR;
							}
							if (_tmp842_) {
								_tmp841_ = TRUE;
							} else {
								ValaBinaryOperator _tmp845_;
								_tmp845_ = self->priv->_operator;
								_tmp841_ = _tmp845_ == VALA_BINARY_OPERATOR_BITWISE_XOR;
							}
							if (_tmp841_) {
								ValaExpression* _tmp846_;
								ValaExpression* _tmp847_;
								ValaDataType* _tmp848_;
								ValaDataType* _tmp849_;
								ValaExpression* _tmp850_;
								ValaExpression* _tmp851_;
								ValaDataType* _tmp852_;
								ValaDataType* _tmp853_;
								ValaExpression* _tmp854_;
								ValaExpression* _tmp855_;
								ValaDataType* _tmp856_;
								ValaDataType* _tmp857_;
								ValaDataType* _tmp858_;
								ValaDataType* _tmp859_;
								_tmp846_ = vala_binary_expression_get_left (self);
								_tmp847_ = _tmp846_;
								_tmp848_ = vala_expression_get_target_type (_tmp847_);
								_tmp849_ = _tmp848_;
								vala_data_type_set_nullable (_tmp849_, FALSE);
								_tmp850_ = vala_binary_expression_get_right (self);
								_tmp851_ = _tmp850_;
								_tmp852_ = vala_expression_get_target_type (_tmp851_);
								_tmp853_ = _tmp852_;
								vala_data_type_set_nullable (_tmp853_, FALSE);
								_tmp854_ = vala_binary_expression_get_left (self);
								_tmp855_ = _tmp854_;
								_tmp856_ = vala_expression_get_target_type (_tmp855_);
								_tmp857_ = _tmp856_;
								_tmp858_ = vala_data_type_copy (_tmp857_);
								_tmp859_ = _tmp858_;
								vala_expression_set_value_type ((ValaExpression*) self, _tmp859_);
								_vala_code_node_unref0 (_tmp859_);
							} else {
								gboolean _tmp860_ = FALSE;
								ValaBinaryOperator _tmp861_;
								_tmp861_ = self->priv->_operator;
								if (_tmp861_ == VALA_BINARY_OPERATOR_AND) {
									_tmp860_ = TRUE;
								} else {
									ValaBinaryOperator _tmp862_;
									_tmp862_ = self->priv->_operator;
									_tmp860_ = _tmp862_ == VALA_BINARY_OPERATOR_OR;
								}
								if (_tmp860_) {
									gboolean _tmp863_ = FALSE;
									ValaExpression* _tmp864_;
									ValaExpression* _tmp865_;
									ValaDataType* _tmp866_;
									ValaDataType* _tmp867_;
									ValaCodeContext* _tmp868_;
									ValaSemanticAnalyzer* _tmp869_;
									ValaSemanticAnalyzer* _tmp870_;
									ValaDataType* _tmp871_;
									gboolean _tmp872_;
									ValaExpression* _tmp884_;
									ValaExpression* _tmp885_;
									ValaDataType* _tmp886_;
									ValaDataType* _tmp887_;
									ValaExpression* _tmp888_;
									ValaExpression* _tmp889_;
									ValaDataType* _tmp890_;
									ValaDataType* _tmp891_;
									ValaCodeContext* _tmp892_;
									ValaSemanticAnalyzer* _tmp893_;
									ValaSemanticAnalyzer* _tmp894_;
									ValaDataType* _tmp895_;
									_tmp864_ = vala_binary_expression_get_left (self);
									_tmp865_ = _tmp864_;
									_tmp866_ = vala_expression_get_value_type (_tmp865_);
									_tmp867_ = _tmp866_;
									_tmp868_ = context;
									_tmp869_ = vala_code_context_get_analyzer (_tmp868_);
									_tmp870_ = _tmp869_;
									_tmp871_ = _tmp870_->bool_type;
									_tmp872_ = vala_data_type_compatible (_tmp867_, _tmp871_);
									if (!_tmp872_) {
										_tmp863_ = TRUE;
									} else {
										ValaExpression* _tmp873_;
										ValaExpression* _tmp874_;
										ValaDataType* _tmp875_;
										ValaDataType* _tmp876_;
										ValaCodeContext* _tmp877_;
										ValaSemanticAnalyzer* _tmp878_;
										ValaSemanticAnalyzer* _tmp879_;
										ValaDataType* _tmp880_;
										gboolean _tmp881_;
										_tmp873_ = vala_binary_expression_get_right (self);
										_tmp874_ = _tmp873_;
										_tmp875_ = vala_expression_get_value_type (_tmp874_);
										_tmp876_ = _tmp875_;
										_tmp877_ = context;
										_tmp878_ = vala_code_context_get_analyzer (_tmp877_);
										_tmp879_ = _tmp878_;
										_tmp880_ = _tmp879_->bool_type;
										_tmp881_ = vala_data_type_compatible (_tmp876_, _tmp880_);
										_tmp863_ = !_tmp881_;
									}
									if (_tmp863_) {
										ValaSourceReference* _tmp882_;
										ValaSourceReference* _tmp883_;
										vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
										_tmp882_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
										_tmp883_ = _tmp882_;
										vala_report_error (_tmp883_, "Operands must be boolean");
									}
									_tmp884_ = vala_binary_expression_get_left (self);
									_tmp885_ = _tmp884_;
									_tmp886_ = vala_expression_get_target_type (_tmp885_);
									_tmp887_ = _tmp886_;
									vala_data_type_set_nullable (_tmp887_, FALSE);
									_tmp888_ = vala_binary_expression_get_right (self);
									_tmp889_ = _tmp888_;
									_tmp890_ = vala_expression_get_target_type (_tmp889_);
									_tmp891_ = _tmp890_;
									vala_data_type_set_nullable (_tmp891_, FALSE);
									_tmp892_ = context;
									_tmp893_ = vala_code_context_get_analyzer (_tmp892_);
									_tmp894_ = _tmp893_;
									_tmp895_ = _tmp894_->bool_type;
									vala_expression_set_value_type ((ValaExpression*) self, _tmp895_);
								} else {
									ValaBinaryOperator _tmp896_;
									_tmp896_ = self->priv->_operator;
									if (_tmp896_ == VALA_BINARY_OPERATOR_IN) {
										gboolean _tmp897_ = FALSE;
										ValaExpression* _tmp898_;
										ValaExpression* _tmp899_;
										ValaDataType* _tmp900_;
										ValaDataType* _tmp901_;
										ValaCodeContext* _tmp902_;
										ValaSemanticAnalyzer* _tmp903_;
										ValaSemanticAnalyzer* _tmp904_;
										ValaDataType* _tmp905_;
										gboolean _tmp906_;
										ValaCodeContext* _tmp1019_;
										ValaSemanticAnalyzer* _tmp1020_;
										ValaSemanticAnalyzer* _tmp1021_;
										ValaDataType* _tmp1022_;
										_tmp898_ = vala_binary_expression_get_left (self);
										_tmp899_ = _tmp898_;
										_tmp900_ = vala_expression_get_value_type (_tmp899_);
										_tmp901_ = _tmp900_;
										_tmp902_ = context;
										_tmp903_ = vala_code_context_get_analyzer (_tmp902_);
										_tmp904_ = _tmp903_;
										_tmp905_ = _tmp904_->int_type;
										_tmp906_ = vala_data_type_compatible (_tmp901_, _tmp905_);
										if (_tmp906_) {
											ValaExpression* _tmp907_;
											ValaExpression* _tmp908_;
											ValaDataType* _tmp909_;
											ValaDataType* _tmp910_;
											ValaCodeContext* _tmp911_;
											ValaSemanticAnalyzer* _tmp912_;
											ValaSemanticAnalyzer* _tmp913_;
											ValaDataType* _tmp914_;
											gboolean _tmp915_;
											_tmp907_ = vala_binary_expression_get_right (self);
											_tmp908_ = _tmp907_;
											_tmp909_ = vala_expression_get_value_type (_tmp908_);
											_tmp910_ = _tmp909_;
											_tmp911_ = context;
											_tmp912_ = vala_code_context_get_analyzer (_tmp911_);
											_tmp913_ = _tmp912_;
											_tmp914_ = _tmp913_->int_type;
											_tmp915_ = vala_data_type_compatible (_tmp910_, _tmp914_);
											_tmp897_ = _tmp915_;
										} else {
											_tmp897_ = FALSE;
										}
										if (_tmp897_) {
											ValaExpression* _tmp916_;
											ValaExpression* _tmp917_;
											ValaDataType* _tmp918_;
											ValaDataType* _tmp919_;
											ValaExpression* _tmp920_;
											ValaExpression* _tmp921_;
											ValaDataType* _tmp922_;
											ValaDataType* _tmp923_;
											_tmp916_ = vala_binary_expression_get_left (self);
											_tmp917_ = _tmp916_;
											_tmp918_ = vala_expression_get_target_type (_tmp917_);
											_tmp919_ = _tmp918_;
											vala_data_type_set_nullable (_tmp919_, FALSE);
											_tmp920_ = vala_binary_expression_get_right (self);
											_tmp921_ = _tmp920_;
											_tmp922_ = vala_expression_get_target_type (_tmp921_);
											_tmp923_ = _tmp922_;
											vala_data_type_set_nullable (_tmp923_, FALSE);
										} else {
											ValaExpression* _tmp924_;
											ValaExpression* _tmp925_;
											ValaDataType* _tmp926_;
											ValaDataType* _tmp927_;
											_tmp924_ = vala_binary_expression_get_right (self);
											_tmp925_ = _tmp924_;
											_tmp926_ = vala_expression_get_value_type (_tmp925_);
											_tmp927_ = _tmp926_;
											if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp927_, VALA_TYPE_ARRAY_TYPE)) {
												ValaExpression* _tmp928_;
												ValaExpression* _tmp929_;
												ValaDataType* _tmp930_;
												ValaDataType* _tmp931_;
												ValaExpression* _tmp932_;
												ValaExpression* _tmp933_;
												ValaDataType* _tmp934_;
												ValaDataType* _tmp935_;
												ValaDataType* _tmp936_;
												ValaDataType* _tmp937_;
												gboolean _tmp938_;
												_tmp928_ = vala_binary_expression_get_left (self);
												_tmp929_ = _tmp928_;
												_tmp930_ = vala_expression_get_value_type (_tmp929_);
												_tmp931_ = _tmp930_;
												_tmp932_ = vala_binary_expression_get_right (self);
												_tmp933_ = _tmp932_;
												_tmp934_ = vala_expression_get_value_type (_tmp933_);
												_tmp935_ = _tmp934_;
												_tmp936_ = vala_array_type_get_element_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp935_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
												_tmp937_ = _tmp936_;
												_tmp938_ = vala_data_type_compatible (_tmp931_, _tmp937_);
												if (!_tmp938_) {
													ValaSourceReference* _tmp939_;
													ValaSourceReference* _tmp940_;
													ValaExpression* _tmp941_;
													ValaExpression* _tmp942_;
													ValaDataType* _tmp943_;
													ValaDataType* _tmp944_;
													gchar* _tmp945_;
													gchar* _tmp946_;
													ValaExpression* _tmp947_;
													ValaExpression* _tmp948_;
													ValaDataType* _tmp949_;
													ValaDataType* _tmp950_;
													gchar* _tmp951_;
													gchar* _tmp952_;
													gchar* _tmp953_;
													gchar* _tmp954_;
													_tmp939_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
													_tmp940_ = _tmp939_;
													_tmp941_ = vala_binary_expression_get_left (self);
													_tmp942_ = _tmp941_;
													_tmp943_ = vala_expression_get_value_type (_tmp942_);
													_tmp944_ = _tmp943_;
													_tmp945_ = vala_code_node_to_string ((ValaCodeNode*) _tmp944_);
													_tmp946_ = _tmp945_;
													_tmp947_ = vala_binary_expression_get_right (self);
													_tmp948_ = _tmp947_;
													_tmp949_ = vala_expression_get_value_type (_tmp948_);
													_tmp950_ = _tmp949_;
													_tmp951_ = vala_code_node_to_string ((ValaCodeNode*) _tmp950_);
													_tmp952_ = _tmp951_;
													_tmp953_ = g_strdup_printf ("Cannot look for `%s' in `%s'", _tmp946_, _tmp952_);
													_tmp954_ = _tmp953_;
													vala_report_error (_tmp940_, _tmp954_);
													_g_free0 (_tmp954_);
													_g_free0 (_tmp952_);
													_g_free0 (_tmp946_);
												}
											} else {
												ValaMethod* contains_method = NULL;
												ValaExpression* _tmp955_;
												ValaExpression* _tmp956_;
												ValaDataType* _tmp957_;
												ValaDataType* _tmp958_;
												ValaSymbol* _tmp959_;
												ValaMethod* _tmp960_;
												ValaMethod* _tmp961_;
												ValaMethod* _tmp972_;
												ValaList* _tmp973_;
												ValaList* _tmp974_;
												gint _tmp975_;
												gint _tmp976_;
												gboolean _tmp977_;
												ValaMethod* _tmp985_;
												ValaDataType* _tmp986_;
												ValaDataType* _tmp987_;
												ValaCodeContext* _tmp988_;
												ValaSemanticAnalyzer* _tmp989_;
												ValaSemanticAnalyzer* _tmp990_;
												ValaDataType* _tmp991_;
												gboolean _tmp992_;
												ValaMethodCall* contains_call = NULL;
												ValaExpression* _tmp1000_;
												ValaExpression* _tmp1001_;
												ValaSourceReference* _tmp1002_;
												ValaSourceReference* _tmp1003_;
												ValaMemberAccess* _tmp1004_;
												ValaMemberAccess* _tmp1005_;
												ValaSourceReference* _tmp1006_;
												ValaSourceReference* _tmp1007_;
												ValaMethodCall* _tmp1008_;
												ValaMethodCall* _tmp1009_;
												ValaMethodCall* _tmp1010_;
												ValaExpression* _tmp1011_;
												ValaExpression* _tmp1012_;
												ValaCodeNode* _tmp1013_;
												ValaCodeNode* _tmp1014_;
												ValaMethodCall* _tmp1015_;
												ValaMethodCall* _tmp1016_;
												ValaCodeContext* _tmp1017_;
												gboolean _tmp1018_;
												_tmp955_ = vala_binary_expression_get_right (self);
												_tmp956_ = _tmp955_;
												_tmp957_ = vala_expression_get_value_type (_tmp956_);
												_tmp958_ = _tmp957_;
												_tmp959_ = vala_data_type_get_member (_tmp958_, "contains");
												_tmp960_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp959_, VALA_TYPE_METHOD) ? ((ValaMethod*) _tmp959_) : NULL;
												if (_tmp960_ == NULL) {
													_vala_code_node_unref0 (_tmp959_);
												}
												contains_method = _tmp960_;
												_tmp961_ = contains_method;
												if (_tmp961_ == NULL) {
													ValaSourceReference* _tmp962_;
													ValaSourceReference* _tmp963_;
													ValaExpression* _tmp964_;
													ValaExpression* _tmp965_;
													ValaDataType* _tmp966_;
													ValaDataType* _tmp967_;
													gchar* _tmp968_;
													gchar* _tmp969_;
													gchar* _tmp970_;
													gchar* _tmp971_;
													_tmp962_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
													_tmp963_ = _tmp962_;
													_tmp964_ = vala_binary_expression_get_right (self);
													_tmp965_ = _tmp964_;
													_tmp966_ = vala_expression_get_value_type (_tmp965_);
													_tmp967_ = _tmp966_;
													_tmp968_ = vala_code_node_to_string ((ValaCodeNode*) _tmp967_);
													_tmp969_ = _tmp968_;
													_tmp970_ = g_strdup_printf ("`%s' does not have a `contains' method", _tmp969_);
													_tmp971_ = _tmp970_;
													vala_report_error (_tmp963_, _tmp971_);
													_g_free0 (_tmp971_);
													_g_free0 (_tmp969_);
													vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
													result = FALSE;
													_vala_code_node_unref0 (contains_method);
													return result;
												}
												_tmp972_ = contains_method;
												_tmp973_ = vala_callable_get_parameters ((ValaCallable*) _tmp972_);
												_tmp974_ = _tmp973_;
												_tmp975_ = vala_collection_get_size ((ValaCollection*) _tmp974_);
												_tmp976_ = _tmp975_;
												_tmp977_ = _tmp976_ != 1;
												_vala_iterable_unref0 (_tmp974_);
												if (_tmp977_) {
													ValaSourceReference* _tmp978_;
													ValaSourceReference* _tmp979_;
													ValaMethod* _tmp980_;
													gchar* _tmp981_;
													gchar* _tmp982_;
													gchar* _tmp983_;
													gchar* _tmp984_;
													_tmp978_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
													_tmp979_ = _tmp978_;
													_tmp980_ = contains_method;
													_tmp981_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp980_);
													_tmp982_ = _tmp981_;
													_tmp983_ = g_strdup_printf ("`%s' must have one parameter", _tmp982_);
													_tmp984_ = _tmp983_;
													vala_report_error (_tmp979_, _tmp984_);
													_g_free0 (_tmp984_);
													_g_free0 (_tmp982_);
													vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
													result = FALSE;
													_vala_code_node_unref0 (contains_method);
													return result;
												}
												_tmp985_ = contains_method;
												_tmp986_ = vala_callable_get_return_type ((ValaCallable*) _tmp985_);
												_tmp987_ = _tmp986_;
												_tmp988_ = context;
												_tmp989_ = vala_code_context_get_analyzer (_tmp988_);
												_tmp990_ = _tmp989_;
												_tmp991_ = _tmp990_->bool_type;
												_tmp992_ = vala_data_type_compatible (_tmp987_, _tmp991_);
												if (!_tmp992_) {
													ValaSourceReference* _tmp993_;
													ValaSourceReference* _tmp994_;
													ValaMethod* _tmp995_;
													gchar* _tmp996_;
													gchar* _tmp997_;
													gchar* _tmp998_;
													gchar* _tmp999_;
													_tmp993_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
													_tmp994_ = _tmp993_;
													_tmp995_ = contains_method;
													_tmp996_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp995_);
													_tmp997_ = _tmp996_;
													_tmp998_ = g_strdup_printf ("`%s' must return a boolean value", _tmp997_);
													_tmp999_ = _tmp998_;
													vala_report_error (_tmp994_, _tmp999_);
													_g_free0 (_tmp999_);
													_g_free0 (_tmp997_);
													vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
													result = FALSE;
													_vala_code_node_unref0 (contains_method);
													return result;
												}
												_tmp1000_ = vala_binary_expression_get_right (self);
												_tmp1001_ = _tmp1000_;
												_tmp1002_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
												_tmp1003_ = _tmp1002_;
												_tmp1004_ = vala_member_access_new (_tmp1001_, "contains", _tmp1003_);
												_tmp1005_ = _tmp1004_;
												_tmp1006_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
												_tmp1007_ = _tmp1006_;
												_tmp1008_ = vala_method_call_new ((ValaExpression*) _tmp1005_, _tmp1007_);
												_tmp1009_ = _tmp1008_;
												_vala_code_node_unref0 (_tmp1005_);
												contains_call = _tmp1009_;
												_tmp1010_ = contains_call;
												_tmp1011_ = vala_binary_expression_get_left (self);
												_tmp1012_ = _tmp1011_;
												vala_method_call_add_argument (_tmp1010_, _tmp1012_);
												_tmp1013_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
												_tmp1014_ = _tmp1013_;
												_tmp1015_ = contains_call;
												vala_code_node_replace_expression (_tmp1014_, (ValaExpression*) self, (ValaExpression*) _tmp1015_);
												_tmp1016_ = contains_call;
												_tmp1017_ = context;
												_tmp1018_ = vala_code_node_check ((ValaCodeNode*) _tmp1016_, _tmp1017_);
												result = _tmp1018_;
												_vala_code_node_unref0 (contains_call);
												_vala_code_node_unref0 (contains_method);
												return result;
											}
										}
										_tmp1019_ = context;
										_tmp1020_ = vala_code_context_get_analyzer (_tmp1019_);
										_tmp1021_ = _tmp1020_;
										_tmp1022_ = _tmp1021_->bool_type;
										vala_expression_set_value_type ((ValaExpression*) self, _tmp1022_);
									} else {
										g_assert_not_reached ();
									}
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp1023_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp1024_ = _tmp1023_;
	result = !_tmp1024_;
	return result;
}


static void vala_binary_expression_real_emit (ValaCodeNode* base, ValaCodeGenerator* codegen) {
	ValaBinaryExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCodeGenerator* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaCodeGenerator* _tmp5_;
	ValaCodeGenerator* _tmp6_;
	ValaCodeGenerator* _tmp7_;
	self = (ValaBinaryExpression*) base;
	g_return_if_fail (codegen != NULL);
	_tmp0_ = vala_binary_expression_get_left (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = codegen;
	vala_code_node_emit ((ValaCodeNode*) _tmp1_, _tmp2_);
	_tmp3_ = vala_binary_expression_get_right (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = codegen;
	vala_code_node_emit ((ValaCodeNode*) _tmp4_, _tmp5_);
	_tmp6_ = codegen;
	vala_code_visitor_visit_binary_expression ((ValaCodeVisitor*) _tmp6_, self);
	_tmp7_ = codegen;
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) _tmp7_, (ValaExpression*) self);
}


static void vala_binary_expression_real_get_defined_variables (ValaCodeNode* base, ValaCollection* collection) {
	ValaBinaryExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCollection* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaCollection* _tmp5_;
	self = (ValaBinaryExpression*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_binary_expression_get_left (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = collection;
	vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp1_, _tmp2_);
	_tmp3_ = vala_binary_expression_get_right (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = collection;
	vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp4_, _tmp5_);
}


static void vala_binary_expression_real_get_used_variables (ValaCodeNode* base, ValaCollection* collection) {
	ValaBinaryExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCollection* _tmp2_;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaCollection* _tmp5_;
	self = (ValaBinaryExpression*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_binary_expression_get_left (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = collection;
	vala_code_node_get_used_variables ((ValaCodeNode*) _tmp1_, _tmp2_);
	_tmp3_ = vala_binary_expression_get_right (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = collection;
	vala_code_node_get_used_variables ((ValaCodeNode*) _tmp4_, _tmp5_);
}


ValaBinaryOperator vala_binary_expression_get_operator (ValaBinaryExpression* self) {
	ValaBinaryOperator result;
	ValaBinaryOperator _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_operator;
	result = _tmp0_;
	return result;
}


void vala_binary_expression_set_operator (ValaBinaryExpression* self, ValaBinaryOperator value) {
	ValaBinaryOperator _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_operator = _tmp0_;
}


ValaExpression* vala_binary_expression_get_left (ValaBinaryExpression* self) {
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_left;
	result = _tmp0_;
	return result;
}


void vala_binary_expression_set_left (ValaBinaryExpression* self, ValaExpression* value) {
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _vala_code_node_ref0 (_tmp0_);
	_vala_code_node_unref0 (self->priv->_left);
	self->priv->_left = _tmp1_;
	_tmp2_ = self->priv->_left;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp2_, (ValaCodeNode*) self);
}


ValaExpression* vala_binary_expression_get_right (ValaBinaryExpression* self) {
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_right;
	result = _tmp0_;
	return result;
}


void vala_binary_expression_set_right (ValaBinaryExpression* self, ValaExpression* value) {
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _vala_code_node_ref0 (_tmp0_);
	_vala_code_node_unref0 (self->priv->_right);
	self->priv->_right = _tmp1_;
	_tmp2_ = self->priv->_right;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp2_, (ValaCodeNode*) self);
}


static void vala_binary_expression_class_init (ValaBinaryExpressionClass * klass) {
	vala_binary_expression_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_binary_expression_finalize;
	g_type_class_add_private (klass, sizeof (ValaBinaryExpressionPrivate));
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_binary_expression_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_binary_expression_real_accept_children;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode *, ValaExpression*, ValaExpression*)) vala_binary_expression_real_replace_expression;
	((ValaCodeNodeClass *) klass)->to_string = (gchar* (*) (ValaCodeNode *)) vala_binary_expression_real_to_string;
	((ValaExpressionClass *) klass)->is_constant = (gboolean (*) (ValaExpression *)) vala_binary_expression_real_is_constant;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression *)) vala_binary_expression_real_is_pure;
	((ValaExpressionClass *) klass)->is_non_null = (gboolean (*) (ValaExpression *)) vala_binary_expression_real_is_non_null;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression *, ValaSymbol*)) vala_binary_expression_real_is_accessible;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode *, ValaCodeContext*)) vala_binary_expression_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode *, ValaCodeGenerator*)) vala_binary_expression_real_emit;
	((ValaCodeNodeClass *) klass)->get_defined_variables = (void (*) (ValaCodeNode *, ValaCollection*)) vala_binary_expression_real_get_defined_variables;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode *, ValaCollection*)) vala_binary_expression_real_get_used_variables;
}


static void vala_binary_expression_instance_init (ValaBinaryExpression * self) {
	self->priv = VALA_BINARY_EXPRESSION_GET_PRIVATE (self);
}


static void vala_binary_expression_finalize (ValaCodeNode * obj) {
	ValaBinaryExpression * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_BINARY_EXPRESSION, ValaBinaryExpression);
	_vala_code_node_unref0 (self->priv->_left);
	_vala_code_node_unref0 (self->priv->_right);
	VALA_CODE_NODE_CLASS (vala_binary_expression_parent_class)->finalize (obj);
}


/**
 * Represents an expression with two operands in the source code.
 *
 * Supports +, -, *, /, %, <<, >>, <, >, <=, >=, ==, !=, &, |, ^, &&, ||, ??.
 */
GType vala_binary_expression_get_type (void) {
	static volatile gsize vala_binary_expression_type_id__volatile = 0;
	if (g_once_init_enter (&vala_binary_expression_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaBinaryExpressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_binary_expression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaBinaryExpression), 0, (GInstanceInitFunc) vala_binary_expression_instance_init, NULL };
		GType vala_binary_expression_type_id;
		vala_binary_expression_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaBinaryExpression", &g_define_type_info, 0);
		g_once_init_leave (&vala_binary_expression_type_id__volatile, vala_binary_expression_type_id);
	}
	return vala_binary_expression_type_id__volatile;
}


GType vala_binary_operator_get_type (void) {
	static volatile gsize vala_binary_operator_type_id__volatile = 0;
	if (g_once_init_enter (&vala_binary_operator_type_id__volatile)) {
		static const GEnumValue values[] = {{VALA_BINARY_OPERATOR_NONE, "VALA_BINARY_OPERATOR_NONE", "none"}, {VALA_BINARY_OPERATOR_PLUS, "VALA_BINARY_OPERATOR_PLUS", "plus"}, {VALA_BINARY_OPERATOR_MINUS, "VALA_BINARY_OPERATOR_MINUS", "minus"}, {VALA_BINARY_OPERATOR_MUL, "VALA_BINARY_OPERATOR_MUL", "mul"}, {VALA_BINARY_OPERATOR_DIV, "VALA_BINARY_OPERATOR_DIV", "div"}, {VALA_BINARY_OPERATOR_MOD, "VALA_BINARY_OPERATOR_MOD", "mod"}, {VALA_BINARY_OPERATOR_SHIFT_LEFT, "VALA_BINARY_OPERATOR_SHIFT_LEFT", "shift-left"}, {VALA_BINARY_OPERATOR_SHIFT_RIGHT, "VALA_BINARY_OPERATOR_SHIFT_RIGHT", "shift-right"}, {VALA_BINARY_OPERATOR_LESS_THAN, "VALA_BINARY_OPERATOR_LESS_THAN", "less-than"}, {VALA_BINARY_OPERATOR_GREATER_THAN, "VALA_BINARY_OPERATOR_GREATER_THAN", "greater-than"}, {VALA_BINARY_OPERATOR_LESS_THAN_OR_EQUAL, "VALA_BINARY_OPERATOR_LESS_THAN_OR_EQUAL", "less-than-or-equal"}, {VALA_BINARY_OPERATOR_GREATER_THAN_OR_EQUAL, "VALA_BINARY_OPERATOR_GREATER_THAN_OR_EQUAL", "greater-than-or-equal"}, {VALA_BINARY_OPERATOR_EQUALITY, "VALA_BINARY_OPERATOR_EQUALITY", "equality"}, {VALA_BINARY_OPERATOR_INEQUALITY, "VALA_BINARY_OPERATOR_INEQUALITY", "inequality"}, {VALA_BINARY_OPERATOR_BITWISE_AND, "VALA_BINARY_OPERATOR_BITWISE_AND", "bitwise-and"}, {VALA_BINARY_OPERATOR_BITWISE_OR, "VALA_BINARY_OPERATOR_BITWISE_OR", "bitwise-or"}, {VALA_BINARY_OPERATOR_BITWISE_XOR, "VALA_BINARY_OPERATOR_BITWISE_XOR", "bitwise-xor"}, {VALA_BINARY_OPERATOR_AND, "VALA_BINARY_OPERATOR_AND", "and"}, {VALA_BINARY_OPERATOR_OR, "VALA_BINARY_OPERATOR_OR", "or"}, {VALA_BINARY_OPERATOR_IN, "VALA_BINARY_OPERATOR_IN", "in"}, {VALA_BINARY_OPERATOR_COALESCE, "VALA_BINARY_OPERATOR_COALESCE", "coalesce"}, {0, NULL, NULL}};
		GType vala_binary_operator_type_id;
		vala_binary_operator_type_id = g_enum_register_static ("ValaBinaryOperator", values);
		g_once_init_leave (&vala_binary_operator_type_id__volatile, vala_binary_operator_type_id);
	}
	return vala_binary_operator_type_id__volatile;
}



