/* valapostfixexpression.c generated by valac, the Vala compiler
 * generated from valapostfixexpression.vala, do not modify */

/* valapostfixexpression.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <valagee.h>
#include <stdlib.h>
#include <string.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValaPostfixExpressionPrivate {
	gboolean _increment;
	ValaExpression* _inner;
};


static gpointer vala_postfix_expression_parent_class = NULL;

#define VALA_POSTFIX_EXPRESSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_POSTFIX_EXPRESSION, ValaPostfixExpressionPrivate))
static void vala_postfix_expression_real_accept (ValaCodeNode* base, ValaCodeVisitor* visitor);
static void vala_postfix_expression_real_accept_children (ValaCodeNode* base, ValaCodeVisitor* visitor);
static gboolean vala_postfix_expression_real_is_pure (ValaExpression* base);
static gboolean vala_postfix_expression_real_is_accessible (ValaExpression* base, ValaSymbol* sym);
static void vala_postfix_expression_real_get_defined_variables (ValaCodeNode* base, ValaCollection* collection);
static void vala_postfix_expression_real_get_used_variables (ValaCodeNode* base, ValaCollection* collection);
static gboolean vala_postfix_expression_real_check (ValaCodeNode* base, ValaCodeContext* context);
static void vala_postfix_expression_real_emit (ValaCodeNode* base, ValaCodeGenerator* codegen);
static void vala_postfix_expression_finalize (ValaCodeNode * obj);


/**
 * Creates a new postfix expression.
 *
 * @param _inner  operand expression
 * @param inc     true for increment, false for decrement
 * @param source  reference to source code
 * @return newly  created postfix expression
 */
ValaPostfixExpression* vala_postfix_expression_construct (GType object_type, ValaExpression* _inner, gboolean inc, ValaSourceReference* source) {
	ValaPostfixExpression* self = NULL;
	ValaExpression* _tmp0_;
	gboolean _tmp1_;
	ValaSourceReference* _tmp2_;
	g_return_val_if_fail (_inner != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	self = (ValaPostfixExpression*) vala_expression_construct (object_type);
	_tmp0_ = _inner;
	vala_postfix_expression_set_inner (self, _tmp0_);
	_tmp1_ = inc;
	vala_postfix_expression_set_increment (self, _tmp1_);
	_tmp2_ = source;
	vala_code_node_set_source_reference ((ValaCodeNode*) self, _tmp2_);
	return self;
}


ValaPostfixExpression* vala_postfix_expression_new (ValaExpression* _inner, gboolean inc, ValaSourceReference* source) {
	return vala_postfix_expression_construct (VALA_TYPE_POSTFIX_EXPRESSION, _inner, inc, source);
}


static void vala_postfix_expression_real_accept (ValaCodeNode* base, ValaCodeVisitor* visitor) {
	ValaPostfixExpression * self;
	ValaCodeVisitor* _tmp0_;
	ValaCodeVisitor* _tmp1_;
	self = (ValaPostfixExpression*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = visitor;
	vala_code_visitor_visit_postfix_expression (_tmp0_, self);
	_tmp1_ = visitor;
	vala_code_visitor_visit_expression (_tmp1_, (ValaExpression*) self);
}


static void vala_postfix_expression_real_accept_children (ValaCodeNode* base, ValaCodeVisitor* visitor) {
	ValaPostfixExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCodeVisitor* _tmp2_;
	self = (ValaPostfixExpression*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_postfix_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = visitor;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, _tmp2_);
}


static gboolean vala_postfix_expression_real_is_pure (ValaExpression* base) {
	ValaPostfixExpression * self;
	gboolean result = FALSE;
	self = (ValaPostfixExpression*) base;
	result = FALSE;
	return result;
}


static gboolean vala_postfix_expression_real_is_accessible (ValaExpression* base, ValaSymbol* sym) {
	ValaPostfixExpression * self;
	gboolean result = FALSE;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaSymbol* _tmp2_;
	gboolean _tmp3_;
	self = (ValaPostfixExpression*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	_tmp0_ = vala_postfix_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = sym;
	_tmp3_ = vala_expression_is_accessible (_tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


static gpointer _vala_code_node_ref0 (gpointer self) {
	return self ? vala_code_node_ref (self) : NULL;
}


static void vala_postfix_expression_real_get_defined_variables (ValaCodeNode* base, ValaCollection* collection) {
	ValaPostfixExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCollection* _tmp2_;
	ValaLocalVariable* local = NULL;
	ValaExpression* _tmp3_;
	ValaExpression* _tmp4_;
	ValaSymbol* _tmp5_;
	ValaSymbol* _tmp6_;
	ValaLocalVariable* _tmp7_;
	ValaParameter* param = NULL;
	ValaExpression* _tmp8_;
	ValaExpression* _tmp9_;
	ValaSymbol* _tmp10_;
	ValaSymbol* _tmp11_;
	ValaParameter* _tmp12_;
	ValaLocalVariable* _tmp13_;
	self = (ValaPostfixExpression*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_postfix_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = collection;
	vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp1_, _tmp2_);
	_tmp3_ = vala_postfix_expression_get_inner (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = vala_expression_get_symbol_reference (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, VALA_TYPE_LOCAL_VARIABLE) ? ((ValaLocalVariable*) _tmp6_) : NULL);
	local = _tmp7_;
	_tmp8_ = vala_postfix_expression_get_inner (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = vala_expression_get_symbol_reference (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, VALA_TYPE_PARAMETER) ? ((ValaParameter*) _tmp11_) : NULL);
	param = _tmp12_;
	_tmp13_ = local;
	if (_tmp13_ != NULL) {
		ValaCollection* _tmp14_;
		ValaLocalVariable* _tmp15_;
		_tmp14_ = collection;
		_tmp15_ = local;
		vala_collection_add (_tmp14_, (ValaVariable*) _tmp15_);
	} else {
		gboolean _tmp16_ = FALSE;
		ValaParameter* _tmp17_;
		_tmp17_ = param;
		if (_tmp17_ != NULL) {
			ValaParameter* _tmp18_;
			ValaParameterDirection _tmp19_;
			ValaParameterDirection _tmp20_;
			_tmp18_ = param;
			_tmp19_ = vala_parameter_get_direction (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp16_ = _tmp20_ == VALA_PARAMETER_DIRECTION_OUT;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			ValaCollection* _tmp21_;
			ValaParameter* _tmp22_;
			_tmp21_ = collection;
			_tmp22_ = param;
			vala_collection_add (_tmp21_, (ValaVariable*) _tmp22_);
		}
	}
	_vala_code_node_unref0 (param);
	_vala_code_node_unref0 (local);
}


static void vala_postfix_expression_real_get_used_variables (ValaCodeNode* base, ValaCollection* collection) {
	ValaPostfixExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCollection* _tmp2_;
	self = (ValaPostfixExpression*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_postfix_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = collection;
	vala_code_node_get_used_variables ((ValaCodeNode*) _tmp1_, _tmp2_);
}


static gboolean vala_postfix_expression_real_check (ValaCodeNode* base, ValaCodeContext* context) {
	ValaPostfixExpression * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaExpression* _tmp4_;
	ValaExpression* _tmp5_;
	ValaExpression* _tmp6_;
	ValaExpression* _tmp7_;
	ValaCodeContext* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	ValaExpression* _tmp12_;
	ValaExpression* _tmp13_;
	ValaDataType* _tmp14_;
	ValaDataType* _tmp15_;
	ValaExpression* _tmp26_;
	ValaExpression* _tmp27_;
	ValaExpression* _tmp64_;
	ValaExpression* _tmp65_;
	ValaExpression* _tmp94_;
	ValaExpression* _tmp95_;
	ValaDataType* _tmp96_;
	ValaDataType* _tmp97_;
	gboolean _tmp98_;
	gboolean _tmp99_;
	self = (ValaPostfixExpression*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_postfix_expression_get_inner (self);
	_tmp5_ = _tmp4_;
	vala_expression_set_lvalue (_tmp5_, TRUE);
	_tmp6_ = vala_postfix_expression_get_inner (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = context;
	_tmp9_ = vala_code_node_check ((ValaCodeNode*) _tmp7_, _tmp8_);
	if (!_tmp9_) {
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		result = FALSE;
		return result;
	}
	_tmp12_ = vala_postfix_expression_get_inner (self);
	_tmp13_ = _tmp12_;
	_tmp14_ = vala_expression_get_value_type (_tmp13_);
	_tmp15_ = _tmp14_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, VALA_TYPE_INTEGER_TYPE)) {
		ValaExpression* _tmp16_;
		ValaExpression* _tmp17_;
		ValaDataType* _tmp18_;
		ValaDataType* _tmp19_;
		_tmp16_ = vala_postfix_expression_get_inner (self);
		_tmp17_ = _tmp16_;
		_tmp18_ = vala_expression_get_value_type (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp11_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, VALA_TYPE_FLOATING_TYPE);
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		ValaExpression* _tmp20_;
		ValaExpression* _tmp21_;
		ValaDataType* _tmp22_;
		ValaDataType* _tmp23_;
		_tmp20_ = vala_postfix_expression_get_inner (self);
		_tmp21_ = _tmp20_;
		_tmp22_ = vala_expression_get_value_type (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp10_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, VALA_TYPE_POINTER_TYPE);
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		ValaSourceReference* _tmp24_;
		ValaSourceReference* _tmp25_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp24_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp25_ = _tmp24_;
		vala_report_error (_tmp25_, "unsupported lvalue in postfix expression");
		result = FALSE;
		return result;
	}
	_tmp26_ = vala_postfix_expression_get_inner (self);
	_tmp27_ = _tmp26_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, VALA_TYPE_MEMBER_ACCESS)) {
		ValaMemberAccess* ma = NULL;
		ValaExpression* _tmp28_;
		ValaExpression* _tmp29_;
		ValaMemberAccess* _tmp30_;
		ValaMemberAccess* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp33_;
		gboolean _tmp43_ = FALSE;
		ValaMemberAccess* _tmp44_;
		gboolean _tmp45_;
		gboolean _tmp46_;
		_tmp28_ = vala_postfix_expression_get_inner (self);
		_tmp29_ = _tmp28_;
		_tmp30_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, VALA_TYPE_MEMBER_ACCESS, ValaMemberAccess));
		ma = _tmp30_;
		_tmp31_ = ma;
		_tmp32_ = vala_member_access_get_prototype_access (_tmp31_);
		_tmp33_ = _tmp32_;
		if (_tmp33_) {
			ValaSourceReference* _tmp34_;
			ValaSourceReference* _tmp35_;
			ValaMemberAccess* _tmp36_;
			ValaSymbol* _tmp37_;
			ValaSymbol* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp34_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp35_ = _tmp34_;
			_tmp36_ = ma;
			_tmp37_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp36_);
			_tmp38_ = _tmp37_;
			_tmp39_ = vala_symbol_get_full_name (_tmp38_);
			_tmp40_ = _tmp39_;
			_tmp41_ = g_strdup_printf ("Access to instance member `%s' denied", _tmp40_);
			_tmp42_ = _tmp41_;
			vala_report_error (_tmp35_, _tmp42_);
			_g_free0 (_tmp42_);
			_g_free0 (_tmp40_);
			result = FALSE;
			_vala_code_node_unref0 (ma);
			return result;
		}
		_tmp44_ = ma;
		_tmp45_ = vala_code_node_get_error ((ValaCodeNode*) _tmp44_);
		_tmp46_ = _tmp45_;
		if (_tmp46_) {
			_tmp43_ = TRUE;
		} else {
			ValaMemberAccess* _tmp47_;
			ValaSymbol* _tmp48_;
			ValaSymbol* _tmp49_;
			_tmp47_ = ma;
			_tmp48_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp47_);
			_tmp49_ = _tmp48_;
			_tmp43_ = _tmp49_ == NULL;
		}
		if (_tmp43_) {
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			result = FALSE;
			_vala_code_node_unref0 (ma);
			return result;
		}
		_vala_code_node_unref0 (ma);
	} else {
		ValaExpression* _tmp50_;
		ValaExpression* _tmp51_;
		_tmp50_ = vala_postfix_expression_get_inner (self);
		_tmp51_ = _tmp50_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp51_, VALA_TYPE_ELEMENT_ACCESS)) {
			ValaElementAccess* ea = NULL;
			ValaExpression* _tmp52_;
			ValaExpression* _tmp53_;
			ValaElementAccess* _tmp54_;
			ValaElementAccess* _tmp55_;
			ValaExpression* _tmp56_;
			ValaExpression* _tmp57_;
			ValaDataType* _tmp58_;
			ValaDataType* _tmp59_;
			_tmp52_ = vala_postfix_expression_get_inner (self);
			_tmp53_ = _tmp52_;
			_tmp54_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, VALA_TYPE_ELEMENT_ACCESS, ValaElementAccess));
			ea = _tmp54_;
			_tmp55_ = ea;
			_tmp56_ = vala_element_access_get_container (_tmp55_);
			_tmp57_ = _tmp56_;
			_tmp58_ = vala_expression_get_value_type (_tmp57_);
			_tmp59_ = _tmp58_;
			if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp59_, VALA_TYPE_ARRAY_TYPE)) {
				ValaSourceReference* _tmp60_;
				ValaSourceReference* _tmp61_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp60_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp61_ = _tmp60_;
				vala_report_error (_tmp61_, "unsupported lvalue in postfix expression");
				result = FALSE;
				_vala_code_node_unref0 (ea);
				return result;
			}
			_vala_code_node_unref0 (ea);
		} else {
			ValaSourceReference* _tmp62_;
			ValaSourceReference* _tmp63_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp62_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp63_ = _tmp62_;
			vala_report_error (_tmp63_, "unsupported lvalue in postfix expression");
			result = FALSE;
			return result;
		}
	}
	_tmp64_ = vala_postfix_expression_get_inner (self);
	_tmp65_ = _tmp64_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp65_, VALA_TYPE_MEMBER_ACCESS)) {
		ValaMemberAccess* ma = NULL;
		ValaExpression* _tmp66_;
		ValaExpression* _tmp67_;
		ValaMemberAccess* _tmp68_;
		ValaMemberAccess* _tmp69_;
		ValaSymbol* _tmp70_;
		ValaSymbol* _tmp71_;
		_tmp66_ = vala_postfix_expression_get_inner (self);
		_tmp67_ = _tmp66_;
		_tmp68_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, VALA_TYPE_MEMBER_ACCESS, ValaMemberAccess));
		ma = _tmp68_;
		_tmp69_ = ma;
		_tmp70_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp69_);
		_tmp71_ = _tmp70_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp71_, VALA_TYPE_PROPERTY)) {
			ValaProperty* prop = NULL;
			ValaMemberAccess* _tmp72_;
			ValaSymbol* _tmp73_;
			ValaSymbol* _tmp74_;
			ValaProperty* _tmp75_;
			gboolean _tmp76_ = FALSE;
			ValaProperty* _tmp77_;
			ValaPropertyAccessor* _tmp78_;
			ValaPropertyAccessor* _tmp79_;
			_tmp72_ = ma;
			_tmp73_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp72_);
			_tmp74_ = _tmp73_;
			_tmp75_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, VALA_TYPE_PROPERTY, ValaProperty));
			prop = _tmp75_;
			_tmp77_ = prop;
			_tmp78_ = vala_property_get_set_accessor (_tmp77_);
			_tmp79_ = _tmp78_;
			if (_tmp79_ == NULL) {
				_tmp76_ = TRUE;
			} else {
				ValaProperty* _tmp80_;
				ValaPropertyAccessor* _tmp81_;
				ValaPropertyAccessor* _tmp82_;
				gboolean _tmp83_;
				gboolean _tmp84_;
				_tmp80_ = prop;
				_tmp81_ = vala_property_get_set_accessor (_tmp80_);
				_tmp82_ = _tmp81_;
				_tmp83_ = vala_property_accessor_get_writable (_tmp82_);
				_tmp84_ = _tmp83_;
				_tmp76_ = !_tmp84_;
			}
			if (_tmp76_) {
				ValaMemberAccess* _tmp85_;
				ValaMemberAccess* _tmp86_;
				ValaSourceReference* _tmp87_;
				ValaSourceReference* _tmp88_;
				ValaProperty* _tmp89_;
				gchar* _tmp90_;
				gchar* _tmp91_;
				gchar* _tmp92_;
				gchar* _tmp93_;
				_tmp85_ = ma;
				vala_code_node_set_error ((ValaCodeNode*) _tmp85_, TRUE);
				_tmp86_ = ma;
				_tmp87_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp86_);
				_tmp88_ = _tmp87_;
				_tmp89_ = prop;
				_tmp90_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp89_);
				_tmp91_ = _tmp90_;
				_tmp92_ = g_strdup_printf ("Property `%s' is read-only", _tmp91_);
				_tmp93_ = _tmp92_;
				vala_report_error (_tmp88_, _tmp93_);
				_g_free0 (_tmp93_);
				_g_free0 (_tmp91_);
				result = FALSE;
				_vala_code_node_unref0 (prop);
				_vala_code_node_unref0 (ma);
				return result;
			}
			_vala_code_node_unref0 (prop);
		}
		_vala_code_node_unref0 (ma);
	}
	_tmp94_ = vala_postfix_expression_get_inner (self);
	_tmp95_ = _tmp94_;
	_tmp96_ = vala_expression_get_value_type (_tmp95_);
	_tmp97_ = _tmp96_;
	vala_expression_set_value_type ((ValaExpression*) self, _tmp97_);
	_tmp98_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp99_ = _tmp98_;
	result = !_tmp99_;
	return result;
}


static void vala_postfix_expression_real_emit (ValaCodeNode* base, ValaCodeGenerator* codegen) {
	ValaPostfixExpression * self;
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaCodeGenerator* _tmp2_;
	ValaCodeGenerator* _tmp3_;
	ValaCodeGenerator* _tmp4_;
	self = (ValaPostfixExpression*) base;
	g_return_if_fail (codegen != NULL);
	_tmp0_ = vala_postfix_expression_get_inner (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = codegen;
	vala_code_node_emit ((ValaCodeNode*) _tmp1_, _tmp2_);
	_tmp3_ = codegen;
	vala_code_visitor_visit_postfix_expression ((ValaCodeVisitor*) _tmp3_, self);
	_tmp4_ = codegen;
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) _tmp4_, (ValaExpression*) self);
}


ValaExpression* vala_postfix_expression_get_inner (ValaPostfixExpression* self) {
	ValaExpression* result;
	ValaExpression* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_inner;
	result = _tmp0_;
	return result;
}


void vala_postfix_expression_set_inner (ValaPostfixExpression* self, ValaExpression* value) {
	ValaExpression* _tmp0_;
	ValaExpression* _tmp1_;
	ValaExpression* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _vala_code_node_ref0 (_tmp0_);
	_vala_code_node_unref0 (self->priv->_inner);
	self->priv->_inner = _tmp1_;
	_tmp2_ = self->priv->_inner;
	vala_code_node_set_parent_node ((ValaCodeNode*) _tmp2_, (ValaCodeNode*) self);
}


gboolean vala_postfix_expression_get_increment (ValaPostfixExpression* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_increment;
	result = _tmp0_;
	return result;
}


void vala_postfix_expression_set_increment (ValaPostfixExpression* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_increment = _tmp0_;
}


static void vala_postfix_expression_class_init (ValaPostfixExpressionClass * klass) {
	vala_postfix_expression_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_postfix_expression_finalize;
	g_type_class_add_private (klass, sizeof (ValaPostfixExpressionPrivate));
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_postfix_expression_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode *, ValaCodeVisitor*)) vala_postfix_expression_real_accept_children;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression *)) vala_postfix_expression_real_is_pure;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression *, ValaSymbol*)) vala_postfix_expression_real_is_accessible;
	((ValaCodeNodeClass *) klass)->get_defined_variables = (void (*) (ValaCodeNode *, ValaCollection*)) vala_postfix_expression_real_get_defined_variables;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode *, ValaCollection*)) vala_postfix_expression_real_get_used_variables;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode *, ValaCodeContext*)) vala_postfix_expression_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode *, ValaCodeGenerator*)) vala_postfix_expression_real_emit;
}


static void vala_postfix_expression_instance_init (ValaPostfixExpression * self) {
	self->priv = VALA_POSTFIX_EXPRESSION_GET_PRIVATE (self);
}


static void vala_postfix_expression_finalize (ValaCodeNode * obj) {
	ValaPostfixExpression * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_POSTFIX_EXPRESSION, ValaPostfixExpression);
	_vala_code_node_unref0 (self->priv->_inner);
	VALA_CODE_NODE_CLASS (vala_postfix_expression_parent_class)->finalize (obj);
}


/**
 * Represents a postfix increment or decrement expression.
 */
GType vala_postfix_expression_get_type (void) {
	static volatile gsize vala_postfix_expression_type_id__volatile = 0;
	if (g_once_init_enter (&vala_postfix_expression_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaPostfixExpressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_postfix_expression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaPostfixExpression), 0, (GInstanceInitFunc) vala_postfix_expression_instance_init, NULL };
		GType vala_postfix_expression_type_id;
		vala_postfix_expression_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaPostfixExpression", &g_define_type_info, 0);
		g_once_init_leave (&vala_postfix_expression_type_id__volatile, vala_postfix_expression_type_id);
	}
	return vala_postfix_expression_type_id__volatile;
}



